using System;
using System.Data;
using System.Xml;
using Wrox.Payments;

namespace Example3
{
	/// <summary>
	/// Summary description for Class1.
	/// </summary>
	class Class1
	{
		static void Main(string[] args)
		{
			// Create a typed DataSet
			WroxAuthors wrox = new WroxAuthors();

			// Create an XmlDataDocument and synchronize to the dataset
			XmlDataDocument doc = new XmlDataDocument(wrox);

			// Load the XML document
			doc.Load("Payment.xml");

			// pay the authors
			foreach (WroxAuthors.PaymentRow paid in wrox.Payment)
			{
				paid.Paid = true;
			}
				
			// save the new document
			doc.Save("Payment_Done.xml");
		}
	}
}
