Module Module1
    
    Sub Main()
        ' Open the connection
        Dim dbConn As New SqlClient.SqlConnection("server=localhost;uid=sa;pwd=;database=pubs")
        Try
            ' Create Authors DataTable
            Dim dtAuthors As New DataTable("Authors")

            ' Create a DataAdapter to fill the table
            Dim daAuthors As New SqlClient.SqlDataAdapter("SELECT au_id,au_fname,au_lname FROM authors", dbConn)
            daAuthors.Fill(dtAuthors)

            ' I'm looking for a record without case-sensitive comparison
            dtAuthors.CaseSensitive = False
            Dim r() As DataRow
            r = dtAuthors.Select("au_lname = 'karsen'")

            ' Print to video
            If r.Length > 0 Then
                Console.WriteLine("Found: " + r(0)("au_lname"))
            Else
                Console.WriteLine("Nothing found")
            End If

            ' And with case-sensitive comparison
            dtAuthors.CaseSensitive = True
            r = dtAuthors.Select("au_lname = 'karsen'")

            ' Print to video
            If r.Length > 0 Then
                Console.WriteLine("Found: " + r(0)("au_lname"))
            Else
                Console.WriteLine("Nothing found")
            End If

        Catch e As Exception
            Console.WriteLine(e.Message)
        Finally
            If dbConn.State = ConnectionState.Open Then dbConn.Close()
        End Try
    End Sub
    
End Module
