<%@ Import Namespace="System.Web.UI.WebControls" %>
<%@ Page language="c#" Codebehind="EventBubbling.aspx.cs" AutoEventWireup="false" Inherits="Chapter19.EventBubbling" smartNavigation="True"%>
<HTML>
	<HEAD>
		<title>EventBubbling</title>
	</HEAD>
	<body>
		<form id="EventBubbling" method="post" runat="server">
			<asp:datagrid id="DataGrid1" runat="server" DataKeyField="id" AutoGenerateColumns="False">
				<AlternatingItemStyle BackColor="#AEBEA2"></AlternatingItemStyle>
				<ItemStyle Font-Size="11pt"></ItemStyle>
				<HeaderStyle Font-Size="Small" Font-Bold="True" ForeColor="White" BackColor="Green"></HeaderStyle>
				<Columns>
					<asp:EditCommandColumn ButtonType="LinkButton" UpdateText="" CancelText="" EditText="">
						<ItemStyle VerticalAlign="Top"></ItemStyle>
					</asp:EditCommandColumn>
					<asp:ButtonColumn Text="" CommandName="Delete">
						<ItemStyle VerticalAlign="Top"></ItemStyle>
					</asp:ButtonColumn>
					<asp:ButtonColumn Text="" CommandName="Select">
						<ItemStyle VerticalAlign="Top"></ItemStyle>
					</asp:ButtonColumn>
					<asp:BoundColumn DataField="title" HeaderText="">
						<ItemStyle VerticalAlign="Top"></ItemStyle>
					</asp:BoundColumn>
					<asp:TemplateColumn HeaderText="">
						<ItemStyle VerticalAlign="Top"></ItemStyle>
						<ItemTemplate>
							<B>:</B>
							<%# DataBinder.Eval(Container.DataItem, "author" ) %>
							<BR>
							<B>:</B>
							<%# DataBinder.Eval(Container.DataItem, "price", "{0:c}" ) %>
							<BR>
							<B>:</B>
							<%# DataBinder.Eval(Container.DataItem, "page") %>
							<BR>
							<B>:</B>
							<%# DataBinder.Eval(Container.DataItem, "publishDate", "{0:yyyy-MM-dd}" ) %>
							<BR>
							<B>:</B>
							<BR>
							<BLOCKQUOTE><%# DataBinder.Eval(Container.DataItem, "Description") %></BLOCKQUOTE>
						</ItemTemplate>
						<EditItemTemplate>
							<B>:</B><BR>
							<asp:TextBox id=txtAuthor runat="server" Text='<%# DataBinder.Eval(Container.DataItem, "author" ) %>'>
							</asp:TextBox><BR>
							<B>:</B><BR>
							<asp:TextBox id=txtPrice runat="server" Text='<%# DataBinder.Eval(Container.DataItem, "price" ) %>'>
							</asp:TextBox><BR>
							<B>:</B><BR>
							<asp:TextBox id=txtPage runat="server" Text='<%# DataBinder.Eval(Container.DataItem, "page") %>'>
							</asp:TextBox><BR>
							<B>:</B><BR>
							<asp:Calendar id=calPublishDate runat="server" VisibleDate='<%# DataBinder.Eval(Container.DataItem, "publishDate") %>' SelectedDate='<%# DataBinder.Eval(Container.DataItem, "publishDate") %>'>
							</asp:Calendar><BR>
							<B>:</B>
							<BR>
							<asp:TextBox id=txtDescription runat="server" Text='<%# DataBinder.Eval(Container.DataItem, "Description") %>' TextMode="MultiLine" Columns="40" Rows="5">
							</asp:TextBox>
						</EditItemTemplate>
					</asp:TemplateColumn>
					<asp:TemplateColumn HeaderText="ư">
						<ItemStyle VerticalAlign="Top"></ItemStyle>
						<ItemTemplate>
							<asp:Button id=btnEdit runat="server" Text="" CommandName="<%# DataGrid.EditCommandName %>">
							</asp:Button><BR>
							<asp:Button id=btnDelete runat="server" Text="" CommandName="<%# DataGrid.DeleteCommandName %>">
							</asp:Button><BR>
							<asp:Button id="btnSelect" runat="server" Text="" CommandName="<%# DataGrid.SelectCommandName %>">
							</asp:Button><BR>
							<asp:Button id="btnAny" runat="server" Text="Any" CommandName="UserDefine"></asp:Button>
						</ItemTemplate>
						<EditItemTemplate>
							<asp:Button id=btnUpdate runat="server" Text="" CommandName="<%# DataGrid.UpdateCommandName %>">
							</asp:Button><BR>
							<asp:Button id=btnCancel runat="server" Text="" CommandName="<%# DataGrid.CancelCommandName %>">
							</asp:Button>
						</EditItemTemplate>
					</asp:TemplateColumn>
				</Columns>
			</asp:datagrid>
		</form>
	</body>
</HTML>
