<%@ Import Namespace="System.Data" %>
<%@ Import Namespace="System.Data.SqlClient" %>
<%@ Import Namespace="System.Data.Common" %>
<HTML>
	<script language="C#" runat="server">
	public ICollection GetData()
	{
		string strSqlConn = ConfigurationSettings.AppSettings["SqlConnectionString"];
		string strQuery = "select * from tbDataPresentation2";
		SqlConnection sqlConn = new SqlConnection(strSqlConn);
		SqlDataAdapter da = new SqlDataAdapter(strQuery, sqlConn);

		DataSet ds = new DataSet();
		da.Fill(ds, "DataPresentation2");
		return ds.Tables["DataPresentation2"].DefaultView;
	}

	void Page_Load(Object sender, EventArgs e) 
	{
		DataGrid1.DataSource = GetData();
		DataGrid1.DataBind();
	}

	void Item_Bound(Object sender, DataGridItemEventArgs e) 
	{
		if (e.Item.ItemType == ListItemType.Item || 
			e.Item.ItemType == ListItemType.AlternatingItem)
		{
			//Response.Write("DataItem =" + e.Item.DataItem.GetType().ToString() + "<br>");
			//DbDataRecord dr = (DbDataRecord)e.Item.DataItem;
			DataRowView dr = (DataRowView)e.Item.DataItem;
			Response.Write("DataItem[\"id\"]=" + dr["id"] + "<br>");
			Response.Write("DataItem[\"title\"]=" + dr["title"] + "<br>");

			string cell1 = e.Item.Cells[0].Text;
			string cell2 = ((DataBoundLiteralControl)e.Item.Cells[1].Controls[0]).Text;
			Response.Write("Cells[0]=" + cell1 + "<br>");
			Response.Write("Cells[1].Controls[0]=" + cell2 + "<br>");
			Response.Write("<br>");
		}
	}

	</script>
	<BODY>
		<form method="post" runat="server">
			<asp:datagrid id="DataGrid1" runat="server" AutoGenerateColumns="False" OnItemDataBound="Item_Bound" AllowPaging="true" PageSize="4">
				<HeaderStyle BackColor="#00AAAA"></HeaderStyle>
				<PagerStyle BackColor="#00AAAA"></PagerStyle>
				<Columns>
					<asp:BoundColumn DataField="title" HeaderText=""></asp:BoundColumn>
					<asp:TemplateColumn HeaderText="">
						<ItemTemplate>
							:
							<%# DataBinder.Eval(Container.DataItem, "author" ) %>
						</ItemTemplate>
					</asp:TemplateColumn>
				</Columns>
			</asp:datagrid>
		</form>
	</BODY>
</HTML>
