using System;
using System.Web.UI;
using System.Web.UI.WebControls;

namespace CustomControls.Start
{
	public class WebControlStart4 : WebControl
	{
		public WebControlStart4() : base(HtmlTextWriterTag.Select) {}

		protected override void RenderContents(System.Web.UI.HtmlTextWriter writer)
		{
			for (int i=1;i<6;i++)
			{
				writer.AddAttribute(HtmlTextWriterAttribute.Value, i.ToString());
				writer.RenderBeginTag(HtmlTextWriterTag.Option);
				writer.Write(i + "° ׸");
				writer.RenderEndTag();
				writer.WriteLine();
			}

			base.RenderContents(writer);
		}

		protected override void AddAttributesToRender(System.Web.UI.HtmlTextWriter writer)
		{
			writer.AddAttribute(HtmlTextWriterAttribute.Onchange, "alert('õ  : ' + this.options[this.selectedIndex].value)");
			base.AddAttributesToRender(writer);
		}

	}
}
