using System;
using System.IO;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.ComponentModel;

namespace CustomControls.Start
{
	public class FirstControl : WebControl
	{
		// The message property.
		private String myMessage = "Hello";

		// Accessors for the message property.
		public virtual String Message {
			get {return myMessage;}
			set {myMessage = value;}
		}

		protected override void Render(HtmlTextWriter writer) 
		{

			writer.Write("Encoding : " + writer.Encoding.ToString() + "<br>");

			writer.WriteLine();
			// Output the 'font' html tag.
			writer.WriteBeginTag("font");
			// Output the 'color' attribute for the 'font' tag.
			writer.WriteAttribute("color", "red");
			// Output the '>' char to close the 'font' tag.
			writer.Write('>');

			TextWriter innerTextWriter = writer.InnerWriter;
			innerTextWriter.Write(Message + "<br> The time on the server :" +
				System.DateTime.Now.ToLongTimeString());

			// Output the end of 'font' tag.
			writer.WriteEndTag("font");


			writer.WriteLine();
			// Output the 'font' html tag.
			writer.WriteBeginTag("font");
			// Output the 'color' attribute for the 'font' tag.
			writer.WriteAttribute("color", "red");
			// Output the '>' char to close the 'font' tag.
			writer.Write('>');

			//TextWriter innerTextWriter = writer.InnerWriter;
			writer.Write(Message + "<br> The time on the server :" +
				System.DateTime.Now.ToLongTimeString());

			// Output the end of 'font' tag.
			writer.WriteEndTag("font");
			writer.WriteLine();
		}
	}
}

