var Page_SimpleValidationVer = "1";
var Page_IsValid = true;  
var Page_BlockSubmit = false;

function ValidatorUpdateDisplay(val) {
    val.style.visibility = (val.isvalid || !val.messagedisplay) ? "hidden" : "visible";
}

function ValidatorUpdateIsValid() {
    var i;

    for (i = 0; i < Page_Validators.length; i++) {
        if (!Page_Validators[i].isvalid) {
            Page_IsValid = false;
            return;
        }
   }
   Page_IsValid = true;
}

//Ʈѿ ͸ ߰Ѵ.
function ValidatorHookupControl(control, val) {
    if (typeof(control.Validators) == "undefined") {
        control.Validators = new Array;
        var func = new Function("ValidatorOnChange('" + control.id + "');");
        control.onchange = func;
    }
    control.Validators[control.Validators.length] = val;
}

//־ id Ʈѿ  ´.
function ValidatorGetValue(id) {
    var control;
    control = document.getElementById(id);
    if (typeof(control.value) == "string") {
        return control.value;
    }

	return "";
}

function Page_ClientValidate() {
    var i, val;
	var errorFocusControl = null;
	var boxErrorMessage;

    for (i = 0; i < Page_Validators.length; i++) {
		val = Page_Validators[i];
        ValidatorValidate(val);
		if (errorFocusControl == null && !val.isvalid)
		{
			errorFocusControl = document.getElementById(val.getAttribute("controltovalidate"));
			boxErrorMessage = val.getAttribute("errormessage");
		}
    }
    ValidatorUpdateIsValid();    
    Page_BlockSubmit = !Page_IsValid;
	if (errorFocusControl != null)
	{
		alert(boxErrorMessage);
		errorFocusControl.focus();
	}

    return Page_IsValid;
}

function ValidatorCommonOnSubmit() {
    var returnValue =  !Page_BlockSubmit;
    Page_BlockSubmit = false;    
    return returnValue;
}

function ValidatorOnChange(controlID) {
    var cont = document.getElementById(controlID);
    var vals = cont.Validators;
    var i;
    for (i = 0; i < vals.length; i++) {
        ValidatorValidate(vals[i]);
    }
    ValidatorUpdateIsValid();
}

function ValidatorValidate(val) {    
    val.isvalid = true;
    if (typeof(val.evalfunc) == "function") {
        val.isvalid = val.evalfunc(val); 
    }

    ValidatorUpdateDisplay(val);
	/*
	if (!val.isvalid && val.controlfocusonerror)
	{
		var control = document.getElementById(val.getAttribute("controltovalidate"));
		control.focus();
	}*/
}


function ValidatorOnLoad() {
    if (typeof(Page_Validators) == "undefined")
       return;

    var i, val;
    for (i = 0; i < Page_Validators.length; i++) {
        val = Page_Validators[i];

		var evalFunction = val.getAttribute("evaluationfunction");
        if (typeof(evalFunction) == "string") {
            eval("val.evalfunc = " + evalFunction + ";");
        }

		/*
		var evalControlFocusOnError = val.getAttribute("controlfocusonerror");
        if (typeof(evalControlFocusOnError) == "string") {
            eval("val.controlfocusonerror = " + evalControlFocusOnError + ";");
        }
		*/
		
		var evalMessageDisplay = val.getAttribute("messagedisplay");
        if (typeof(evalMessageDisplay) == "string") {
            eval("val.messagedisplay = " + evalMessageDisplay + ";");
        }


        var isValidAttribute = val.getAttribute("isvalid");
        if (typeof(isValidAttribute) == "string") {
            if (isValidAttribute == "False") {
                val.isvalid = false;                                
                Page_IsValid = false;
            } 
            else {
                val.isvalid = true;
            }
        } else {
            val.isvalid = true;
        }

        var controlToValidate = val.getAttribute("controltovalidate");
        if (typeof(controlToValidate) == "string") {
            ValidatorHookupControl(document.getElementById(controlToValidate), val);
        }        
    }

	//ȿ ˻ Ȱȭ
    Page_ValidationActive = true;
}

function RegularExpressionValidatorEvaluateIsValid(val) {
    var value = ValidatorGetValue(val.getAttribute("controltovalidate"));
    if (value == "")
        return true;        
    var rx = new RegExp(val.getAttribute("validationexpression"));
    var matches = rx.exec(value);
    return (matches != null && value == matches[0]);
}

function ValidatorTrim(s) {
    var m = s.match(/^\s*(.*\S)\s*$/);
    return (m == null) ? "" : m[1];
}

function RequiredFieldValidatorEvaluateIsValid(val) {
    return (ValidatorTrim(ValidatorGetValue(val.getAttribute("controltovalidate"))) != ValidatorTrim(val.getAttribute("initialvalue")));
}

function CustomValidatorEvaluateIsValid(val) {
    var value = "";
    if (typeof(val.controltovalidate) == "string") {
        value = ValidatorGetValue(val.controltovalidate);
        if (ValidatorTrim(value).length == 0)
            return true;
    }
    var args = { Value:value, IsValid:true };
    if (typeof(val.clientvalidationfunction) == "string") {
        eval(val.clientvalidationfunction + "(val, args) ;");
    }        
    return args.IsValid;
}
