namespace PowerOfDotNet.Avatar
{
	using System;
	using System.Data;
	using System.Data.SqlClient;
	using System.Drawing;
	using System.Web;
	using System.Web.UI;
	using System.Web.UI.WebControls;
	using System.Web.UI.HtmlControls;

	public abstract class AvatarPlugIn : System.Web.UI.UserControl
	{
		protected System.Web.UI.HtmlControls.HtmlGenericControl divBox;
		protected System.Web.UI.WebControls.PlaceHolder plachdrDiv;
		protected System.Web.UI.WebControls.Label lblCaption;

		//ƹŸ 콺 巡 Ҷ ʿ ũƮ
		private string scriptDragAvatar = @"
<SCRIPT language=""JavaScript"">
<!--
var dragItem;
var dragApproved=false;

//콺 ̸ ȣȴ.
function drag_dropie()
{
	//콺 ư ִٸ
	if (dragApproved)
	{
		//ƹŸ ǥ̵
		dragItem.style.pixelLeft=tempx+event.clientX-iex;
		dragItem.style.pixelTop=tempy+event.clientY-iey;
		return false;
	}
}

//巡׸ 
function InitializeDrag(objName)
{
	dragItem = document.getElementById(objName);
	iex=event.clientX;
	iey=event.clientY;
	tempx=dragItem.style.pixelLeft;
	tempy=dragItem.style.pixelTop;
	dragApproved=true;
	document.onmousemove=drag_dropie;
}

//onmouseup ̺Ʈ 巹 
if (document.all)
{
	document.onmouseup=new Function(""dragApproved=false"");
}

//-->
</SCRIPT>
		";

		private int _expression = 0;
		protected System.Web.UI.HtmlControls.HtmlTable tableOuter;
		protected System.Web.UI.HtmlControls.HtmlTable tableInner;
		protected System.Web.UI.HtmlControls.HtmlTableCell cellInner;
		private string _userId = String.Empty;
		private bool _dragable = false;

		// ڽ ִ θ Ѵ.
		public string ViewFrame {
			set {
				if (value.ToLower() == "false")	{
					tableOuter.CellSpacing = 0;
					tableOuter.CellPadding = 0;
					tableOuter.BgColor = String.Empty;
					tableInner.BgColor = String.Empty;
					cellInner.BgColor = String.Empty;
				}
				else {
					tableOuter.CellSpacing = 0;
					tableOuter.CellPadding = 1;
					tableOuter.BgColor = "#83a8d6";
					tableInner.BgColor = "#bababa";
					cellInner.BgColor = "#ffffff";
				}
			}
		}

		//ƹŸ 巡   ִ 
		public bool Dragable {
			set {_dragable = value;}
			get {return _dragable;}
		}

		//ƹŸ   ID
		public string UserID {
			set	{_userId = value;}
		}

		//ƹŸ ǥ
		public string Expression {
			set	{_expression = Convert.ToInt32(value);}
		}

		//ư Ŭ 
		public string OnClick {
			set	{tableOuter.Attributes["onclick"] = value;}
		}

		//ƹŸ  ǥ
		public string Left {
			set	{divBox.Style["left"] = value;}
		}

		//ƹŸ  ǥ
		public string Top {
			set	{divBox.Style["top"] = value;}
		}

		//ĸ ڿ
		public string Caption {
			set	{lblCaption.Text = value;}
		}

		//position Ÿ
		public string Position	{
			set	{divBox.Style["position"] = value;}
		}

		private void Page_Load(object sender, System.EventArgs e)
		{
			PowerOfDotNet.Components.AvatarDB db = new PowerOfDotNet.Components.AvatarDB();

			if (_userId != String.Empty) 
			{
				SqlDataReader dr = db.GetUserAvater(_userId);
				bool dataEmpty = true;

				// ƹŸ    
				//µǵ HTML ҽ Ѵ.
				while (dr.Read()) {
					string strDiv = "<DIV STYLE='position:absolute; left:0; top:0; z-index:" + dr["LayerNum"].ToString()
						+ "'><img id=layerimgl1 src='" + dr["ImageName"].ToString() + "' border=0 align=absmiddle></DIV>";
					plachdrDiv.Controls.Add(new LiteralControl(strDiv));
					dataEmpty = false;
				}
				dr.Close();

				//ڰ ƹŸ  ʾҴٸ
				//⺻ ƹŸ Ѵ.
				if (dataEmpty) {
					dr = db.GetDefaultAvatar();
					while (dr.Read()) {
						string strDiv = "<DIV STYLE='position:absolute; left:0; top:0; z-index:" + dr["LayerNum"].ToString()
							+ "'><img id=layerimgl1 src='" + dr["ImageName"].ToString() + "' border=0 align=absmiddle></DIV>";
						plachdrDiv.Controls.Add(new LiteralControl(strDiv));
					}
					dr.Close();
				}

				//ǥ Ǿ ǥ ߰Ѵ
				if (_expression != 0) {
					SqlDataReader drExp = db.GetAvatarExpressionItem(_expression);
					if (drExp.Read()) {
						string strDiv = "<DIV STYLE='position:absolute; left:0; top:0; z-index:" + drExp["LayerNum"].ToString()
							+ "'><img id=layerimgl1 src='" + drExp["ImageName"].ToString() + "' border=0 align=absmiddle></DIV>";
						plachdrDiv.Controls.Add(new LiteralControl(strDiv));
					}
					drExp.Close();
				}

				if (Dragable) {
					//ƹŸ 巡 ϴµ ʿ ũƮ 
					this.Page.RegisterClientScriptBlock("_scriptDragAvatar", scriptDragAvatar);
					//onmousedown̸ InitializeDrag Լ ȣѴ.
					tableOuter.Attributes["onmousedown"] = "InitializeDrag('" + divBox.ClientID + "')";
				}
			}
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN:  ȣ ASP.NET Web Form ̳ʿ ʿմϴ.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		///		̳  ʿ ޼Դϴ.
		///		 ޼  ڵ   ʽÿ.
		/// </summary>
		private void InitializeComponent()
		{
			this.Load += new System.EventHandler(this.Page_Load);
		}
		#endregion
	}
}
