namespace PowerOfDotNet.NewStudy.Lacture
{
	using System;
	using System.Data;
	using System.Data.SqlClient;
	using System.Drawing;
	using System.Web;
	using System.Web.UI;
	using System.Web.UI.WebControls;
	using System.Web.UI.HtmlControls;
	using System.Collections;

	/// <summary>
	///		List   Դϴ.
	/// </summary>
	public abstract class LactureList : PowerOfDotNet.PortalModuleControlEx
	{
		protected MyWebLibs.ServerControls.PagerSkinGrid LactureGrid;
		protected System.Web.UI.HtmlControls.HtmlInputHidden LactureParams;
		protected System.Web.UI.WebControls.Image NewImage;
		protected System.Web.UI.HtmlControls.HtmlInputText txtSearch;
		protected System.Web.UI.WebControls.RadioButtonList rdobtnlstSearchType;
		protected System.Web.UI.WebControls.RequiredFieldValidator RequiredFieldValidator1;
		protected System.Web.UI.WebControls.Button btnSearch;
		protected System.Web.UI.WebControls.Button btnPrevSearch;
		protected System.Web.UI.WebControls.Label lblSqlConditions;
		protected System.Web.UI.WebControls.CheckBox RowCheckbox;
		protected System.Web.UI.WebControls.Label Space;
		protected System.Web.UI.WebControls.Image Image1;
		protected System.Web.UI.HtmlControls.HtmlInputButton btnWriteNew;
		protected System.Web.UI.WebControls.HyperLink hyplnkEdit;
		protected System.Web.UI.WebControls.Panel pnlHeader;

		// Խù  Ÿ GET Ķ 
		private string makeLactureContentParamScript = @"
<SCRIPT LANGUAGE=""JavaScript"">
		<!--
		function MakeLactureContentParam()
		{{
			var groupId = null;
			var id = """";
			var groupNum = 0;
			var GroupArr = new Array();
			var param = """";
			var added = false;
	
			for (var i=0;i<__LactureListCheckBoxArr.length;i++)
			{{
				if (__LactureListCheckBoxArr[i][0].checked)
				{{
					if (groupId == null)
					{{
						id = __LactureListCheckBoxArr[i][1];
						groupId = __LactureListCheckBoxArr[i][2];
					}}
					else if (groupId != __LactureListCheckBoxArr[i][2])
					{{
						GroupArr[groupNum] = ""group"" + groupNum + ""="" + groupId + "":"" + id;
						groupNum++;
						id = __LactureListCheckBoxArr[i][1];
						groupId = __LactureListCheckBoxArr[i][2];
					}}
					else
					{{
						id += "","" + __LactureListCheckBoxArr[i][1];
					}}
					added = true;
				}}
			}}
	
				if (added)
					GroupArr[groupNum] = ""group"" + groupNum + ""="" + groupId + "":"" + id;
	
				for (var i=0;i<GroupArr.length;i++)
				{{
					param += GroupArr[i] + ""&"";
				}}
				var uri = ""{0}&"" + {1}.value + ""&"" + param;
				window.location.href = uri;
			}}

		//-->
		</SCRIPT>
		";

		private string dreamWeaverScript = @"
<script language=""JavaScript"" src=""{0}/Include/DreamweaverScript.js"">
</script>
		";

		private string lactureSqlConditionViewScript = @"
<SCRIPT LANGUAGE=""JavaScript"">
		<!--
		function _PowerOF_LactureShowSqlConditionViewScript()
		{
			x = (document.layers) ? e.pageX : document.body.scrollLeft+event.clientX;
			y = (document.layers) ? e.pageY : document.body.scrollTop+event.clientY;
			MM_changeProp('dSqlCondition','','style.top', y-30 + '','DIV');

			var obj = MM_findObj('dSqlCondition');
			var left = document.body.clientWidth - ((document.body.clientWidth + 700) / 2);
			MM_changeProp('dSqlCondition','','style.left', left + '','DIV');
			MM_showHideLayers('dSqlCondition','','show');
		}
		//-->
</SCRIPT>
		";

		private int registerArrayCount = 0;
		private PowerOfDotNet.Components.BoardLactureInfo _blInfo;

		private void Page_Load(object sender, System.EventArgs e)
		{
			int boardId = -1;
			try {
				//  ´.
				boardId = Convert.ToInt32(
					this.Settings["TableID"].ToString());
			}
			catch {
				this.Controls.Add(
					new LiteralControl(
					" ⿡  ¾ Ϸ ʾҽϴ"));
				LactureGrid.Visible = false;
				if (this.IsEditable)
				{
					hyplnkEdit.Text = "";
					hyplnkEdit.NavigateUrl = 
						"/NewStudy/Lacture/EditModules/" + 
						"LactureListEdit.aspx?moduleId=" + 
						this.ModuleId;
				}
				return;
			}

			//ɽÿ   ´.
			_blInfo = 
				(PowerOfDotNet.Components.BoardLactureInfo)
				this.GetObjectFromCache("BoardLactureTableInfo" + 
				boardId);
			if (_blInfo == null) {
				PowerOfDotNet.Components.BoardLactureDB db = 
					new PowerOfDotNet.Components.BoardLactureDB();
				_blInfo = db.GetBoardInfo(boardId);

				this.SetObjectToCache("BoardLactureTableInfo" + boardId, _blInfo, 30);
			}

			if (!IsPostBack) {
				bool fristAcc = 
					MyWebLibs.Utilities.CommonMethods.RequestStr(
					Request.Params["firstAcc"], "false") == "true";
				//޴   û Ÿ
				//ǿ  ˻   .
				if (fristAcc)
					while (RemoveLastSqlCondition() > 0) ;

				int page = 
					MyWebLibs.Utilities.CommonMethods.RequestInt(
					Request.Params["page"], 0);
				BindData(page);

				if (this.IsEditable) {
					hyplnkEdit.Text = "";
					hyplnkEdit.NavigateUrl = 
						"/NewStudy/Lacture/EditModules/" + 
						"LactureListEdit.aspx?moduleId=" + 
						this.ModuleId;
				}
				pnlHeader.Style["text-align"] = "center";
			}

			//ŸƲ 
			switch (_blInfo.BBSDisplayType) {
				case 0 :
					pnlHeader.Controls.Add(
						new LiteralControl(_blInfo.BBSSubject));
					pnlHeader.Style["font-size"] = "16px";
					pnlHeader.Style["font-weight"] = "bold";
					break;
				case 1 :
					pnlHeader.Controls.Add(
						new LiteralControl("<img src='" + 
						_blInfo.BBSImage + "' />"));
					break;
				case 2 :
					pnlHeader.Controls.Add(
						new LiteralControl(_blInfo.BBSHtml));
					break;
			}

			bool authority;
			if (PortalSecurity.IsInRoles(_blInfo.BBSRoles))	
				authority = true;
			else if (_blInfo.BBSType == 0)	
				authority = true;
			else	
				authority = false;
			// Խ̸ Ϲ ڴ   Ѵ.
			if (authority) {
				btnWriteNew.Attributes["onclick"] = 
					"window.location.href='" + 
					GetLink(_blInfo.BBSPageNameWrite)  + 
					"&TableId=" + boardId + "'";
			}
			else {
				btnWriteNew.Visible = false;
			}

			//ؽƮ ڽ Ű ġ '˻' ư Ŭ ȿ 
			txtSearch.Attributes["onkeypress"] = 
				"if (event.keyCode==13 && Page_ClientValidate()) {" + 
				Page.GetPostBackEventReference(btnSearch,"") + 
				";return false;}";
			makeLactureContentParamScript = 
				String.Format(makeLactureContentParamScript, 
				GetLink(_blInfo.BBSPageNameContent) + "&TableId=" + 
				boardId, "document.getElementById(\"" + 
				LactureParams.ClientID + "\")");
			Page.RegisterClientScriptBlock(
				"makeLactureContentParamScript", 
				makeLactureContentParamScript);
			
			string path = Request.ApplicationPath;
			if (path[path.Length-1] == '/')
				path = path.Substring(0, path.Length-1);
			dreamWeaverScript = String.Format(dreamWeaverScript, path);
			Page.RegisterClientScriptBlock(
				"dreamWeaverScript", dreamWeaverScript);
			Page.RegisterClientScriptBlock(
				"lactureSqlConditionViewScript", 
				lactureSqlConditionViewScript);

			//Խù ȸ ߺǴ   Ѵ.
			this.Session["LactureForVistedIncrease"] = Request.RawUrl;
		}

		public void BindData(int page)
		{
			LactureGrid.DataSource = CreateDataSource(page);
			this.DataBind();
		}

		//Ÿҽ 
		private ICollection CreateDataSource(int page)
		{
			DataTable dt = new DataTable();
			DataRow dr;

			dt.Columns.Add(new DataColumn("ID", typeof(Int32)));
			dt.Columns.Add(new DataColumn("No", typeof(Int32)));
			dt.Columns.Add(new DataColumn("Subject", typeof(string)));
			dt.Columns.Add(new DataColumn("Writer", typeof(string)));
			dt.Columns.Add(new DataColumn("Viewed", typeof(Int32)));
			dt.Columns.Add(new DataColumn("RegDate", typeof(string)));
			dt.Columns.Add(new DataColumn("Space", typeof(string)));
			dt.Columns.Add(new DataColumn("IsNew", typeof(bool)));
			dt.Columns.Add(new DataColumn("GroupID", typeof(Int32)));
			dt.Columns.Add(new DataColumn("FileCount", typeof(bool)));

			int intRecCount, intPageCount;
			PowerOfDotNet.Components.BoardLactureDB db = 
				new PowerOfDotNet.Components.BoardLactureDB();
			SqlDataReader sdr;

			int intPageSize = LactureGrid.PageSize;
			//ڰ  ˻  ´.
			string sqlCondition = GetSqlCondition();
			if (sqlCondition == "")
				sdr = db.GetList(_blInfo.BBSTable, page+1, 
					intPageSize, out intRecCount, out intPageCount);
			else
				sdr = db.GetListWithWhere(_blInfo.BBSTable, 
					page+1, intPageSize, sqlCondition, 
					out intRecCount, out intPageCount);
			
			LactureGrid.CurrentPageIndex = page;
			LactureGrid.VirtualItemCount = intRecCount;
			//Խù ȣ ϱ Ѵ.
			int intIndex = intRecCount - (intPageSize * LactureGrid.CurrentPageIndex);
			while (sdr.Read()) {
				dr = dt.NewRow();

				dr[0] = sdr.GetInt64(0); //ID
				dr[1] = intIndex--; // Խùȣ
				dr[2] = sdr.GetString(1); //Subject
				dr[3] = sdr.GetString(2); //Writer
				dr[4] = sdr.GetInt32(3); //ȸ
				dr[5] = sdr.GetDateTime(4).ToString("yyyy MM dd"); //RegDate
				DateTime dtRegDate = sdr.GetDateTime(4);
				dr[7] = dtRegDate >= DateTime.Now.AddDays(-1);//New ̹ ÷ 
				dr[8] = sdr.GetInt32(7); //GroupID
				dr[9] = sdr.GetByte(8) > 0; // 

				string sEmail = sdr.GetString(5);
				// ּҰ  ũ
				if (sEmail != null && sEmail != String.Empty) 
					dr[3] = "<a href=\"mailto:" + sEmail + "\">" + dr[3] + "</a>";				

				string sSpace = "";
				// 鿩
				for (int i=0;i<sdr.GetInt32(6);i++) 	
					sSpace += "&nbsp;&nbsp;&nbsp;";
				dr[6] = sSpace;

				dt.Rows.Add(dr);
			}

			return new DataView(dt);
		}

		protected string GetTarget(TableCellCollection oc)
		{
			string id = oc[0].Text;
			string groupId = oc[1].Text;
			string retStr = GetLink(_blInfo.BBSPageNameContent);

			retStr += "&TableId=" + _blInfo.BBSID;
			retStr += "&page=" + LactureGrid.CurrentPageIndex;
			retStr += "&group0=" + groupId + ":" + id;

			return retStr;
		}

		//˻  ° õ ó
		//ư ̺Ʈ  Ǳ 
		//PreRender ̺Ʈ óѴ.
		private void Page_PreRender(object sender, System.EventArgs e)
		{
			btnPrevSearch.Visible = (GetSqlLevel() > 0);
			btnPrevSearch.Attributes["onMouseOver"] = 
				"_PowerOF_LactureShowSqlConditionViewScript();"; 
			btnPrevSearch.Attributes["onMouseOut"] = 
				"MM_showHideLayers('dSqlCondition','','hide');";
			lblSqlConditions.Text = GetUserReaderbleSqlCondition();
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN:  ȣ ASP.NET Web Form ̳ʿ ʿմϴ.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		///		̳  ʿ ޼Դϴ.
		///		 ޼  ڵ   ʽÿ.
		/// </summary>
		private void InitializeComponent()
		{
			this.LactureGrid.PageIndexChanged += new System.Web.UI.WebControls.DataGridPageChangedEventHandler(this.LactureGrid_PageIndexChanged);
			this.LactureGrid.ItemDataBound += new System.Web.UI.WebControls.DataGridItemEventHandler(this.LactureGrid_ItemDataBound);
			this.btnSearch.Click += new System.EventHandler(this.btnSearch_Click);
			this.btnPrevSearch.Click += new System.EventHandler(this.btnPrevSearch_Click);
			this.Load += new System.EventHandler(this.Page_Load);
			this.PreRender += new System.EventHandler(this.Page_PreRender);

		}
		#endregion

		private void LactureGrid_PageIndexChanged(object source, DataGridPageChangedEventArgs e)
		{
			LactureGrid.CurrentPageIndex = e.NewPageIndex;
			BindData(e.NewPageIndex);
		}

		private void LactureGrid_ItemDataBound(object sender, DataGridItemEventArgs e)
		{
			if(e.Item.ItemType == ListItemType.Item || 
				e.Item.ItemType == ListItemType.AlternatingItem) {
				if (((ICollection)((DataGrid)sender).DataSource).Count > registerArrayCount)
				{
					string id = e.Item.Cells[0].Text;
					string groupId = e.Item.Cells[1].Text;
					Control oc = e.Item.Cells[2].FindControl("RowCheckbox");
					this.Page.RegisterArrayDeclaration("__LactureListCheckBoxArr", "new Array(document.getElementById(\"" + oc.ClientID + "\")," + id + "," + groupId + ")");
					registerArrayCount++; // ޼ҵ尡 ѹ̻ ݺǴ 찡 Ƿ
				}
			}
		}

		private void LactureGrid_PreRender(object sender, System.EventArgs e)
		{
			LactureParams.Value = "page=" + LactureGrid.CurrentPageIndex;
		}

		private void btnPrevSearch_Click(object sender, System.EventArgs e)
		{
			RemoveLastSqlCondition();
			BindData(0);
		}

		//˻  ø  int  ȯ
		private int GetSqlLevel()
		{
			string boardKey = this.ModuleId.ToString();
			string strSqlLev;
			try	{
				strSqlLev = this.Session["sqlLev_" + boardKey].ToString();
			}
			catch {
				//    
				//  ߻ ϹǷ
				strSqlLev = "";
				this.Session["sqlLev_" + boardKey] = "";
			}

			if (strSqlLev == "")
				return 0;
			else
				return Convert.ToInt32(strSqlLev);
		}

		//Ǻ   sql̵ where 
		private string GetSqlCondition()
		{
			string sqlParm = "";
			int sqlLev = GetSqlLevel();

			if (sqlLev == 0)
				return "";

			string boardKey = this.ModuleId.ToString();
			//sqlParm  ˻  ߰ ڿ 
			for (int i=1; i<=sqlLev; i++) {
				if (sqlParm == "")
					sqlParm += this.Session["sql" + 
						i + "_" + boardKey].ToString();
				else
					sqlParm += " and " + this.Session["sql" + 
						i + "_" + boardKey].ToString();
			}

			//sqlParm  տ where ߰  ȯ
			return " where " + sqlParm + " ";
		}

		//Ŭ̾Ʈ ڰ ˾  ִ 
		//˻  ڿ ȯѴ.
		private string GetUserReaderbleSqlCondition()
		{
			string sqlParm = "";
			int sqlLev = GetSqlLevel();

			if (sqlLev == 0)
				return "";

			string boardKey = this.ModuleId.ToString();
			for (int i=1; i<=sqlLev; i++) {
				if (sqlParm == "")
					sqlParm += this.Session["sqlKey" + 
						i + "_" + boardKey].ToString();
				else
					sqlParm += ", " + this.Session["sqlKey" + 
						i + "_" + boardKey].ToString();
				sqlParm += "="+this.Session["sqlCondition" + 
					i + "_" + boardKey].ToString();
			}

			return sqlParm;
		}

		//˻  
		private int SaveSqlCondition(string key, string condition)
		{
			int sqlLev = GetSqlLevel();
			string boardKey = this.ModuleId.ToString();

			sqlLev++;
			this.Session["sqlLev" + "_" + boardKey] = sqlLev;
			this.Session["sqlKey" + sqlLev + "_" + boardKey] = key;
			this.Session["sqlCondition" + sqlLev + "_" + boardKey] = condition;
			this.Session["sql" + sqlLev + "_" + boardKey] = 
				key + " Like '%" + condition + "%'";

			return sqlLev;
		}

		private void btnSearch_Click(object sender, System.EventArgs e)
		{
			int sqlLev = SaveSqlCondition(
				rdobtnlstSearchType.SelectedItem.Value, txtSearch.Value);
			//string sql = GetSqlCondition();
			BindData(0);
		}

		//˻      
		//˻  Ѵ.
		private int RemoveLastSqlCondition()
		{
			int sqlLev = GetSqlLevel();
			if (sqlLev == 0) return 0;

			string boardKey = this.ModuleId.ToString();
			this.Session["sqlLev" + "_" + boardKey] = sqlLev - 1;
			this.Session.Remove("sql" + sqlLev + "_" + boardKey);

			return sqlLev-1;
		}
	}
}
