namespace PowerOfDotNet.Shop
{
	using System;
	using System.Data;
	using System.Data.SqlClient;
	using System.Drawing;
	using System.Drawing.Imaging;
	using System.Drawing.Text;
	using System.Drawing.Drawing2D;
	using System.Web;
	using System.Web.UI.WebControls;
	using System.Web.UI.HtmlControls;
	using System.Reflection;
	using System.Collections;
	using System.IO;

	public abstract class ShopSetUpBothAltercast : PowerOfDotNet.PortalModuleControlEx
	{
		protected System.Web.UI.WebControls.TextBox txtOverRotate;
		protected System.Web.UI.WebControls.RangeValidator RangeValidator1;
		protected System.Web.UI.WebControls.DropDownList drpdnlstOverAlpha;
		protected System.Web.UI.WebControls.TextBox txtOverPercent;
		protected System.Web.UI.WebControls.RangeValidator RangeValidator2;
		protected System.Web.UI.WebControls.Button btnSubmit;
		protected System.Web.UI.WebControls.Button btnApply;
		protected System.Web.UI.WebControls.ImageButton ImageButton1;
		protected System.Web.UI.WebControls.Image Image1;
		protected System.Web.UI.WebControls.Image Image2;
		protected System.Web.UI.WebControls.LinkButton lnkbtnChangeOverImage;
		protected System.Web.UI.HtmlControls.HtmlInputHidden hiddenOverImage;
		protected System.Web.UI.WebControls.Image imgOver;
		protected System.Web.UI.WebControls.Button btnReset;
		protected System.Web.UI.HtmlControls.HtmlInputButton btnOpenOverManagerWin;

		private void Page_Load(object sender, System.EventArgs e)
		{
			if (!IsPostBack)
			{
				string kind = Request.QueryString["kind"];
				if (kind == null)
					throw new Exception("GET Ķͷ kind ޵ ʾҽϴ.");

				ViewState["kind"] = kind;

				for (int i=1;i<=100; i++)
					drpdnlstOverAlpha.Items.Add(i.ToString());

				InitEnv();
			}
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN:  ȣ ASP.NET Web Form ̳ʿ ʿմϴ.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		///		̳  ʿ ޼Դϴ.
		///		 ޼  ڵ   ʽÿ.
		/// </summary>
		private void InitializeComponent()
		{
			this.ImageButton1.Click += new System.Web.UI.ImageClickEventHandler(this.ImageButton1_Click);
			this.btnSubmit.Click += new System.EventHandler(this.btnSubmit_Click);
			this.btnApply.Click += new System.EventHandler(this.btnApply_Click);
			this.btnReset.Click += new System.EventHandler(this.btnReset_Click);
			this.lnkbtnChangeOverImage.Click += new System.EventHandler(this.lnkbtnChangeOverImage_Click);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		private void ImageButton1_Click(object sender, System.Web.UI.ImageClickEventArgs e)
		{
			Confirm(1);
			btnSubmit.Enabled = true;
			btnOpenOverManagerWin.Disabled = false;
			btnApply.Enabled = true;
		}

		private void btnSubmit_Click(object sender, System.EventArgs e)
		{
			Confirm(2);
		}

		private void lnkbtnChangeOverImage_Click(object sender, System.EventArgs e)
		{
			if (ViewState["kind"].ToString() == "B")
				imgOver.ImageUrl = "/Shop/Images/Best/" + hiddenOverImage.Value;
			else
				imgOver.ImageUrl = "/Shop/Images/Recom/" + hiddenOverImage.Value;

			Confirm(2);
		}

		private void btnReset_Click(object sender, System.EventArgs e)
		{
			InitEnv();
		}

		private void btnApply_Click(object sender, System.EventArgs e)
		{
			string overImage = hiddenOverImage.Value;
			int[] overXY = (int[])ViewState["overXY"];
			int[] overStringPosXY = (int[])ViewState["overStringPosXY"];
			int originalSize = (int)ViewState["originalSize"];
			int overRotate;
			int overAlpha;
			int overPercent;
			string kind = ViewState["kind"].ToString();

			try {
				overRotate = int.Parse(txtOverRotate.Text);
			}
			catch {
				overRotate = 0;
			}

			try {
				overAlpha = int.Parse(drpdnlstOverAlpha.SelectedItem.Value);
			}
			catch {
				overAlpha = 100;
			}

			try {
				overPercent = int.Parse(txtOverPercent.Text);
			}
			catch {
				overPercent = 100;
			}

			Components.ShopDB db = new Components.ShopDB();
			db.SaveAltercastImageInfo(kind, "", -1, "",	"", -1,	
				overImage, overXY[0], overXY[1],
				overRotate, overAlpha, overPercent, -1, 
				-1, false, false, originalSize);

			Response.Redirect(GetLink("θ"));
		}

		private void InitEnv()
		{
			int[] overXY = new int[2];
			string overAlpha;
			string kind = ViewState["kind"].ToString();

			PowerOfDotNet.Components.ShopDB db = new PowerOfDotNet.Components.ShopDB();
			SqlDataReader dr = db.GetAltercastImageInfo(kind);

			if (dr.Read())
			{
				hiddenOverImage.Value = dr["overImage"].ToString();

				overXY[0] = (int)dr["overCoordX"];
				overXY[1] = (int)dr["overCoordY"];
				ViewState["overXY"] = overXY;

				txtOverRotate.Text = dr["overRotate"].ToString();

				overAlpha = dr["overAlpha"].ToString();
				drpdnlstOverAlpha.SelectedIndex =
					drpdnlstOverAlpha.Items.IndexOf(
					drpdnlstOverAlpha.Items.FindByValue(overAlpha));

				txtOverPercent.Text = dr["overPercent"].ToString();

				ViewState["originalSize"] = (int)dr["originalSize"];
			}
			else
			{
				hiddenOverImage.Value = "Over1.gif";

				overXY[0] = overXY[1] = -1;
				ViewState["overXY"] = overXY;
				txtOverRotate.Text = "";
				drpdnlstOverAlpha.SelectedIndex = 69;
				txtOverPercent.Text = "";

				ViewState["originalSize"] = -1;
			}

			dr.Close();

			if (kind == "B")
				imgOver.ImageUrl = "/Shop/Images/Best/" + hiddenOverImage.Value;
			else
				imgOver.ImageUrl = "/Shop/Images/Recom/" + hiddenOverImage.Value;

			if (overXY[0] == -1)
			{
				btnSubmit.Enabled = false;
				btnOpenOverManagerWin.Disabled = true;
				btnApply.Enabled = false;
			}
			else
			{
				Confirm(2);
				btnSubmit.Enabled = true;
				btnOpenOverManagerWin.Disabled = false;
				btnApply.Enabled = true;
			}
		}

		private void Confirm(int buttonNum)
		{
			string overImage = hiddenOverImage.Value;
			int[] overXY = null;
			int overRotate;
			int overAlpha;
			int overPercent;

			if (buttonNum == 1)
			{
				overXY = Request.MapImageCoordinates(ImageButton1.UniqueID);
			}
			else if (buttonNum == 2)
			{
				overXY = (int[])ViewState["overXY"];
			}
			else
			{
				overXY = (int[])ViewState["overXY"];
			}

			try 
			{
				overRotate = int.Parse(txtOverRotate.Text);
			}
			catch 
			{
				overRotate = 0;
			}

			try 
			{
				overAlpha = int.Parse(drpdnlstOverAlpha.SelectedItem.Value);
			}
			catch 
			{
				overAlpha = 100;
			}

			try 
			{
				overPercent = int.Parse(txtOverPercent.Text);
			}
			catch 
			{
				overPercent = 100;
			}

			// ̹ ĳϰֱ  ̹ 
			//̸ ٲ Ŭ̾Ʈ ŵ ̹ µȴ.
			string imgName = DateTime.Now.Ticks.ToString();
			string kind = ViewState["kind"].ToString();
			ImageButton1.ImageUrl = "/Shop/Images/CompositionImage" + imgName + kind + "_0.gif";
			Image1.ImageUrl = "/Shop/Images/CompositionImage" + imgName + kind + "_1.gif";
			Image2.ImageUrl = "/Shop/Images/CompositionImage" + imgName + kind + "_2.gif";

			GenerateImage(overImage, overXY, overRotate, overAlpha, 
				overPercent, imgName);

			ViewState["overXY"] = overXY;
		}

		private void GenerateImage(string overImage, int[] overXY, 
			int overRotate, int overAlpha, int overPercent, 
			string resultImageName)
		{
			string kind = ViewState["kind"].ToString();

			Bitmap oBaseImage = new Bitmap(Page.MapPath("/Shop/Images/SampleBaseL.gif"));
			Bitmap oOverImage;
			if (kind == "B")
				oOverImage = new Bitmap(Page.MapPath("/Shop/Images/Best/" + overImage));
			else
				oOverImage = new Bitmap(Page.MapPath("/Shop/Images/Recom/" + overImage));

			int originalSize = oBaseImage.Width;
			ViewState["originalSize"] = originalSize;

			string[] aBaseImages = new string[3];
			//aBaseImages[0] = "SampleBaseL.gif";
			//aBaseImages[1] = "SampleBaseM.gif";
			//aBaseImages[2] = "SampleBaseS.gif";

			aBaseImages[0] = "SampleBaseL.jpg";
			aBaseImages[1] = "SampleBaseM.jpg";
			aBaseImages[2] = "SampleBaseS.jpg";

			for (int i=0; i<3; i++)
			{
				oBaseImage = new Bitmap(Page.MapPath("/Shop/Images/" + aBaseImages[i]));
				Graphics oGraphics = Graphics.FromImage( oBaseImage );

				oGraphics.ResetTransform();

				//GraphicsContainer oGraphicsContainer = oGraphics.BeginContainer();

				//콺 ǥ  ̹  ó ̹
				// Ѵ.
				//̷ ؾ ̹ ũⰡ ٲ  µȴ.
				float scaleValue1 = (float)oBaseImage.Width / (float)originalSize;
				oGraphics.ScaleTransform(scaleValue1, scaleValue1);

				float scaleValue2 = (float)overPercent / 100;
				oGraphics.ScaleTransform(scaleValue2, scaleValue2, MatrixOrder.Append);

				int coordinateX = (int)(overXY[0] * scaleValue1);
				int coordinateY = (int)(overXY[1] * scaleValue1);

				//oGraphics.TranslateTransform(overXY[0], overXY[1], MatrixOrder.Append);
				oGraphics.TranslateTransform(coordinateX, coordinateY, MatrixOrder.Append);

				ColorMatrix myColorMatrix = new ColorMatrix();
				myColorMatrix.Matrix00 = 1.00f; // Red
				myColorMatrix.Matrix11 = 1.00f; // Green
				myColorMatrix.Matrix22 = 1.00f; // Blue
				myColorMatrix.Matrix33 = ((float)overAlpha / 100); // alpha
				myColorMatrix.Matrix44 = 1.00f; // w

				// Create an ImageAttributes object and set the color matrix.
				ImageAttributes imageAttr = new ImageAttributes();
				imageAttr.SetColorMatrix(myColorMatrix);

				Color lowerColor = Color.FromArgb(255,255,255);
				Color upperColor = Color.FromArgb(255,255,255);
				imageAttr.SetColorKey(lowerColor, upperColor);

				//Bitmap oOverImage = new Bitmap(Page.MapPath("ProdImgS_00010.gif"));
				//Bitmap oOverImage = new Bitmap(Page.MapPath("./Image/Best/" + overImage));

				oGraphics.RotateTransform(overRotate);

				oGraphics.CompositingMode = CompositingMode.SourceOver;
				Rectangle rectImg = new Rectangle(0, 0, oOverImage.Width, oOverImage.Height);
				oGraphics.DrawImage(oOverImage,         // Image
					rectImg,            // Dest. rect.
					0,               // srcX
					0,               // srcY
					oOverImage.Width,             // srcWidth
					oOverImage.Height,             // srcHeight
					GraphicsUnit.Pixel, // srcUnit
					imageAttr);      // ImageAttributes

				//oGraphics.EndContainer(oGraphicsContainer);

				string [] files = Directory.GetFiles(MapPath("/Shop/Images/"), "CompositionImage*" + kind + "_" + i + ".gif");
				foreach (string file in files)
					File.Delete(file);
			
				oBaseImage.Save(Page.MapPath("/Shop/Images/CompositionImage" + resultImageName + kind + "_" + i + ".gif"), ImageFormat.Gif);

				oGraphics.Dispose();
			}
			
			oOverImage.Dispose();
			oBaseImage.Dispose();
		}
	}
}
