using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;

namespace PowerOfDotNet.Clubs
{
	/// <summary>
	/// WithdrawFormClub   Դϴ.
	/// </summary>
	public class WithdrawFormClub : System.Web.UI.Page
	{
		private void Page_Load(object sender, System.EventArgs e)
		{
			//clubId, classId, page
			int clubId = MyWebLibs.Utilities.CommonMethods.RequestInt(Request.Params["clubId"], -1);
			int classId = MyWebLibs.Utilities.CommonMethods.RequestInt(Request.Params["classId"], -1);
			int page = MyWebLibs.Utilities.CommonMethods.RequestInt(Request.Params["page"], -1);
			string openerUri = MyWebLibs.Utilities.CommonMethods.RequestStr(Request.Params["openerUri"], "").Replace("^","=").Replace("$","&");

			PowerOfDotNet.Components.ClubsDB db = new PowerOfDotNet.Components.ClubsDB();
			int result = db.WithdrawalFromClub(clubId, this.Page.User.Identity.Name);
			if (result == 1)
			{
				if (openerUri != String.Empty)
					MyWebLibs.Utilities.CommonMethods.PrintMsgRedirectTarget("Ŭ Ż߽ϴ.", openerUri, "_self");
				else
					//Response.Redirect(GetLink("ŬƮ") + "&page=" + page);
					MyWebLibs.Utilities.CommonMethods.PrintMsgBack("Ŭ Ż߽ϴ.");
			}
			else if (result == -2)
				MyWebLibs.Utilities.CommonMethods.PrintMsgBack("û Ż  ϴ.");
			else
				MyWebLibs.Utilities.CommonMethods.PrintMsgBack("Ŭ Ż߽ϴ..");
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN:  ȣ ASP.NET Web Form ̳ʿ ʿմϴ.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// ̳  ʿ ޼Դϴ.
		///  ޼  ڵ   ʽÿ.
		/// </summary>
		private void InitializeComponent()
		{    
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion
	}
}
