namespace PowerOfDotNet.NewStudy.Lacture
{
	using System;
	using System.Data;
	using System.Data.SqlClient;
	using System.Drawing;
	using System.Web;
	using System.Web.UI;
	using System.Web.UI.WebControls;
	using System.Web.UI.HtmlControls;
	using MyWebLibs.Utilities;

	/// <summary>
	///		LactureReply   Դϴ.
	/// </summary>
	public abstract class LactureReply : PowerOfDotNet.PortalModuleControlEx
	{
		protected System.Web.UI.WebControls.TextBox txtSubject;
		protected System.Web.UI.WebControls.RadioButtonList rdobtnFormat;
		protected System.Web.UI.WebControls.TextBox txtContent;
		protected System.Web.UI.HtmlControls.HtmlInputFile File1;
		protected System.Web.UI.HtmlControls.HtmlInputFile File2;
		protected System.Web.UI.HtmlControls.HtmlInputFile File3;
		protected System.Web.UI.HtmlControls.HtmlInputFile File4;
		protected System.Web.UI.HtmlControls.HtmlInputFile File5;
		protected System.Web.UI.HtmlControls.HtmlInputFile File6;
		protected System.Web.UI.HtmlControls.HtmlInputFile File7;
		protected System.Web.UI.HtmlControls.HtmlInputFile File8;
		protected System.Web.UI.HtmlControls.HtmlInputButton btnWriteAndList;
		protected System.Web.UI.WebControls.Panel pnlOrg;
		protected System.Web.UI.HtmlControls.HtmlAnchor aOrg;
		protected System.Web.UI.HtmlControls.HtmlInputButton btnWriteAndBefore;
		protected System.Web.UI.WebControls.RequiredFieldValidator RequiredFieldValidator1;
		protected System.Web.UI.WebControls.RequiredFieldValidator RequiredFieldValidator2;
		protected MyWebLibs.ServerControls.MyValidationSummry MyValidationSummry1;
		protected System.Web.UI.WebControls.Panel pnlHeader;

		private string LactureTogleOrgScript = @"
<script language=""javascript"">
		<!--
		function _PowerOf_TogleOrg(objId) 
		{
			if (document.all[objId].style.display == ""none"") 
			{
				document.all[objId].style.display = """";
			}
			else 
			{
				document.all[objId].style.display = ""none"";
			}
		}
		//-->
		</script>
";
		protected System.Web.UI.WebControls.CheckBox chkboxUseAvatar;
		protected System.Web.UI.WebControls.RadioButtonList rdobtnlstAvatarExp;

		private PowerOfDotNet.Components.BoardLactureInfo _blInfo;

		private void Page_Load(object sender, System.EventArgs e)
		{
			//  ´.
			int boardId = CommonMethods.RequestInt(Request.QueryString["TableId"], -1);

			//߱Ⱓ  ̷ Ѵ.
			//this.RemoveObjectCache("BoardLactureTableInfo" + boardId);
			//ĳÿ   ´.
			_blInfo = (PowerOfDotNet.Components.BoardLactureInfo)this.GetObjectFromCache("BoardLactureTableInfo" + boardId);
			if (_blInfo == null) {
				PowerOfDotNet.Components.BoardLactureDB db = new PowerOfDotNet.Components.BoardLactureDB();
				_blInfo = db.GetBoardInfo(boardId);

				this.SetObjectToCache("BoardLactureTableInfo" + boardId, _blInfo, 30);
			}

			if (!IsPostBack) {
				//GET Ķ͸  ۼ 
				//Ǹ  ڸ ´.
				bool authority;
				if (PortalSecurity.IsInRoles(_blInfo.BBSRoles))	authority = true;
				else if (_blInfo.BBSType == 0)	authority = true;
				else	authority = false;
				// Խ̸ Ϲ ڴ   Ѵ.
				if (!authority) MyWebLibs.Utilities.CommonMethods.PrintMsgBack("ڸ   ֽϴ.");

				ViewState["before"] = MyWebLibs.Utilities.CommonMethods.RequestStr(Request.QueryString["before"], "").Replace("^","=").Replace("$","&");
				//ViewState["TableName"] = tableName;
				ViewState["genParam"] = "page=" + MyWebLibs.Utilities.CommonMethods.RequestStr(Request.QueryString["page"],"") +
					"TableId=" + boardId;

				int id = MyWebLibs.Utilities.CommonMethods.RequestInt(Request.QueryString["id"], 0);
				ViewState["id"] = id;
				PowerOfDotNet.Components.BoardLactureDB db = new PowerOfDotNet.Components.BoardLactureDB();
				SqlDataReader dr = db.GetContent(_blInfo.BBSTable, id);
				dr.Read();
				string org = Server.HtmlEncode(dr.GetString(3)).Replace("\n","<br>");
				pnlOrg.Controls.Clear();
				pnlOrg.Controls.Add(new LiteralControl(org));
				pnlOrg.Attributes["style"] = "display:none;";
				aOrg.Attributes["href"] = "javascript:_PowerOf_TogleOrg('" + pnlOrg.ClientID + "');";
				//txtWriter.Text = dr.GetString(0);
				txtSubject.Text = "[Re]" + dr.GetString(1);
				//txtRegDate.Text = dr.GetDateTime(2).ToString();
				//lblViewed.Text = dr.GetInt32(4).ToString();
				//rdobtnFormat.SelectedIndex = dr.GetByte(6);

				this.Form.Enctype = "multipart/form-data";

				PowerOfDotNet.Components.AvatarDB dbAvatar = new PowerOfDotNet.Components.AvatarDB();
				SqlDataReader drAvatarExp = dbAvatar.GetAvatarExpression();
				rdobtnlstAvatarExp.DataSource = drAvatarExp;
				rdobtnlstAvatarExp.DataTextField = "Description";
				rdobtnlstAvatarExp.DataValueField = "ID";
				rdobtnlstAvatarExp.DataBind();
				rdobtnlstAvatarExp.SelectedIndex = 0;
			}
			Page.RegisterClientScriptBlock("LactureTogleOrgScript", LactureTogleOrgScript);

			pnlHeader.Style["text-align"] = "center";
			//ŸƲ 
			switch (_blInfo.BBSDisplayType)	{
				case 0 :
					pnlHeader.Controls.Add(new LiteralControl(_blInfo.BBSSubject));
					pnlHeader.Style["font-size"] = "16px";
					pnlHeader.Style["font-weight"] = "bold";
					break;
				case 1 :
					pnlHeader.Controls.Add(new LiteralControl("<img src='" + _blInfo.BBSImage + "' />"));
					break;
				case 2 :
					pnlHeader.Controls.Add(new LiteralControl(_blInfo.BBSHtml));
					break;
			}
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN:  ȣ ASP.NET Web Form ̳ʿ ʿմϴ.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		///		̳  ʿ ޼Դϴ.
		///		 ޼  ڵ   ʽÿ.
		/// </summary>
		private void InitializeComponent()
		{
			this.btnWriteAndList.ServerClick += new System.EventHandler(this.btnWriteAndList_ServerClick);
			this.btnWriteAndBefore.ServerClick += new System.EventHandler(this.btnWriteAndBefore_ServerClick);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		private PowerOfDotNet.Components.BoardLactureData MakeDbData()
		{
			PowerOfDotNet.Components.BoardLactureData oData = new PowerOfDotNet.Components.BoardLactureData();
			
			if (Request.IsAuthenticated)
			{
				UsersDB dbUser = new UsersDB();
				SqlDataReader dr = dbUser.GetSingleUser(this.Page.User.Identity.Name);
				dr.Read();

				oData.UserID = this.Page.User.Identity.Name;
				oData.Writer = dr["Name"].ToString();
				oData.Email = dr["Email"].ToString();
			}
			else
			{
				oData.UserID = "";
				oData.Writer = "";
				oData.Email = "";
			}
			oData.ID = Convert.ToInt32(ViewState["id"]);
			oData.Subject = txtSubject.Text;
			oData.Format = Convert.ToByte(rdobtnFormat.SelectedItem.Value);
			oData.Content = txtContent.Text;
			oData.UserIP = Request.ServerVariables["REMOTE_ADDR"];
			oData.UseAvatar = chkboxUseAvatar.Checked;
			oData.AvatarExpression = Convert.ToByte(rdobtnlstAvatarExp.SelectedItem.Value);

			return oData;
		}

		private void btnWriteAndList_ServerClick(object sender, System.EventArgs e)
		{
			PowerOfDotNet.Components.BoardLactureData oData = MakeDbData();
			PowerOfDotNet.Components.BoardLactureDB oDb = new PowerOfDotNet.Components.BoardLactureDB();
			oDb.InsertReply(_blInfo.BBSTable, oData, Request.Files);
			Response.Redirect(GetLink(_blInfo.BBSPageNameList) + "&" + (string)ViewState["genParam"]);
		}

		private void btnWriteAndBefore_ServerClick(object sender, System.EventArgs e)
		{
			PowerOfDotNet.Components.BoardLactureData oData = MakeDbData();
			PowerOfDotNet.Components.BoardLactureDB oDb = new PowerOfDotNet.Components.BoardLactureDB();
			oDb.InsertReply(_blInfo.BBSTable, oData, Request.Files);
			Response.Redirect((string)ViewState["before"]);
		}

	}
}
