using System;
using System.Data;
using System.Data.SqlClient;

namespace MergeExample
{
	/// <summary>
	/// Summary description for Class1.
	/// </summary>
	class Class1
	{
		static void Main(string[] args)
		{
			// Fill a DataSet with data from the pubs database
			SqlConnection dbConn = new SqlConnection("server=localhost;uid=sa;pwd=;database=pubs");
			SqlDataAdapter da = new SqlDataAdapter("SELECT au_id,au_lname,au_fname,contract FROM authors",dbConn);
			DataSet ds = new DataSet("DS");
			DataSet ds2 = new DataSet("DS2");

			// Fill with data and schema
			da.Fill(ds);

			// Only the schema for the other dataset
			da.FillSchema(ds2,SchemaType.Source);
			
			// Print the starting number of rows
			Console.WriteLine("Starting number of rows: {0}", ds.Tables[0].Rows.Count);

			// Add a new row
			DataRow r = ds2.Tables[0].NewRow();
			r["au_id"] = "222-22-2222";
			r["au_fname"] = "Fabio Claudio";
			r["au_lname"] = "Ferracchiati";
			r["contract"] = true;
			ds2.Tables[0].Rows.Add(r);

			// Merge the two DataSets
			ds.Merge(ds2);

			// Print the starting number of rows
			Console.WriteLine("Number of rows after the Merge(): {0}", ds.Tables[0].Rows.Count);		}
	}
}
