Module Module1
    
    Sub Main()
        ' Read XML Schema containing table structure.
        Dim ds As New DataSet("XMLDataSet")
        ds.ReadXmlSchema("C:\AuthorsSchema.XML")

        ' Add a unique constraint on the au_id column
        ds.Tables(0).Constraints.Add("ConstraintID", ds.Tables(0).Columns("au_id"), True)

        ' Add the first record
        Dim dr As DataRow = ds.Tables(0).NewRow()
        dr("au_id") = "222-22-2222"
        dr("au_fname") = "Fabio Claudio"
        dr("au_lname") = "Ferracchiati"
        dr("contract") = 1
        ds.Tables(0).Rows.Add(dr)
        ds.Tables(0).AcceptChanges()

        ' If you set this to true and then try to add the records
        ' below an exception will be raised. False value ignore the
        ' constraint rule for this table.
        ds.EnforceConstraints = False

        ' I can insert another records with the same primary key
        dr = ds.Tables(0).NewRow()
        dr("au_id") = "222-22-2222"
        dr("au_fname") = "Fabio Claudio"
        dr("au_lname") = "Ferracchiati"
        dr("contract") = 1
        ds.Tables(0).Rows.Add(dr)
        ds.Tables(0).AcceptChanges()

    End Sub
    
End Module
