using System;
using System.Data;
using System.Data.SqlClient;
using System.Data.OleDb;
using System.Web.UI.WebControls;
using System.Configuration;

namespace Chapter17.Ex01
{
	public class Chap17_Ex01 : System.Web.UI.Page
	{
		protected System.Web.UI.WebControls.DataGrid DataGrid1;
		protected System.Web.UI.WebControls.Button btnEx01;
		protected System.Web.UI.WebControls.Button btnEx02;	

		private void Page_Load(object sender, System.EventArgs e)
		{
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			InitializeComponent();
			base.OnInit(e);
		}
		
		private void InitializeComponent()
		{    
			this.btnEx01.Click += new System.EventHandler(this.btnEx01_Click);
			this.btnEx02.Click += new System.EventHandler(this.btnEx02_Click);
			this.Load += new System.EventHandler(this.Page_Load);
		}
		#endregion

		private void btnEx01_Click(object sender, System.EventArgs e)
		{
			DB db = new DB();
			string sqlConnStr = ConfigurationSettings.AppSettings["SqlConnectionString"];

			DataSet ds = db.SqlServerProb(sqlConnStr);
			DataGrid1.DataSource = ds.Tables[0].DefaultView;
			DataGrid1.DataBind();
		}

		private void btnEx02_Click(object sender, System.EventArgs e)
		{
			DB db = new DB();
			string oleDbConnStr = ConfigurationSettings.AppSettings["OleDbConnectionString"];

			DataSet ds = db.OleDbProb(oleDbConnStr);
			DataGrid1.DataSource = ds.Tables[0].DefaultView;
			DataGrid1.DataBind();
		}
	}
}
