<%@ Page language="C#" %>
<%@ Import Namespace="System.Data" %>
<HTML>
	<HEAD>
		<TITLE>Chap20_Ex01.aspx</TITLE>
		<script runat="server">

      ICollection CreateDataSource() 
      {
         DataTable dt = new DataTable();
         DataRow dr;
 
         dt.Columns.Add(new DataColumn("ItemName", typeof(string)));
 
         for (int i = 0; i < 10; i++) 
         {
            dr = dt.NewRow();
            dr[0] = " " + i;
            dt.Rows.Add(dr);
         }
 
         DataView dv = new DataView(dt);
         return dv;
      }
 
      void Page_Load(Object sender, EventArgs e) 
      {
         if (!IsPostBack) 
         {
            DataGrid1.DataSource= CreateDataSource();
            DataGrid1.DataBind();
         }
      }
 
      void DataGrid1_ItemCommand(Object sender, DataGridCommandEventArgs e) 
      {
		Response.Write("CommandName=" + e.CommandName + "<br>" +
			"CommandArgument=" + e.CommandArgument + "<br>" +
			"CommandSource ID=" + ((Button)e.CommandSource).ID + 
			"<br>" + "ItemIndex=" + e.Item.ItemIndex + "<br>");
      }

		</script>
	</HEAD>
	<BODY>
		<form method="post" runat="server">
			<asp:DataGrid id="DataGrid1" runat="server" AutoGenerateColumns="False" OnItemCommand="DataGrid1_ItemCommand">
				<AlternatingItemStyle BackColor="#AEBEA2"></AlternatingItemStyle>
				<ItemStyle Font-Size="11pt"></ItemStyle>
				<HeaderStyle Font-Size="Small" Font-Bold="True" ForeColor="White" BackColor="Green"></HeaderStyle>
				<Columns>
					<asp:BoundColumn DataField="ItemName" HeaderText="̸"></asp:BoundColumn>
					<asp:TemplateColumn HeaderText="ư">
						<ItemTemplate>
							<asp:Button ID="btnTest1" runat="server" Text="׽Ʈ1" CommandName="TestCommand1" CommandArgument='<%# "Argument" + ((DataGridItem)Container).ItemIndex + " of TestCommand1" %>'>
							</asp:Button>
							<asp:Button ID="btnTest2" runat="server" Text="׽Ʈ2" CommandName="TestCommand2" CommandArgument='<%# "Argument" + ((DataGridItem)Container).ItemIndex + " of TestCommand2" %>'>
							</asp:Button>
						</ItemTemplate>
					</asp:TemplateColumn>
				</Columns>
			</asp:DataGrid>
		</form>
	</BODY>
</HTML>
