using System.Web.UI;
using System.ComponentModel;

namespace CustomControls.Ex02
{
	[DefaultProperty("Text"), 
	ToolboxData("<{0}:Ex02_Control Text=\"<h3> Ʈ  !<h3>\" runat=server></{0}:Ex02_Control>")]
	public class Ex02_Control : Control
	{
		private string text;

		[Bindable(true), 
		Category("Appearance"), 
		DefaultValue("<h3> Ʈ  !<h3>")] 
		public string Text 
		{
			get	{return text;}
			set	{text = value;}
		}

		protected override void Render(System.Web.UI.HtmlTextWriter writer)
		{
			writer.Write(Text);

			string text = "ڿ";
			writer.Write("<input name=\"" + this.UniqueID + "\" id=\"" + this.ClientID + "\" type=\"text\" value=\"" + text + "\" />");

			writer.WriteBeginTag("input");
			writer.WriteAttribute("name", this.UniqueID);
			writer.WriteAttribute("id", this.ClientID);
			writer.WriteAttribute("type", "text");
			writer.WriteAttribute("value", text);
			writer.Write(HtmlTextWriter.TagRightChar);

			writer.AddAttribute(HtmlTextWriterAttribute.Name, this.UniqueID);
			writer.AddAttribute(HtmlTextWriterAttribute.Id, this.ClientID);
			writer.AddAttribute(HtmlTextWriterAttribute.Type, "text");
			writer.AddAttribute(HtmlTextWriterAttribute.Value, text);
			writer.RenderBeginTag(HtmlTextWriterTag.Input);
			writer.RenderEndTag();
		}
	}
}