<script language="C#" runat="server">

    const int maxRows = 3;
    const int maxCols = 5;

    protected override void Render(HtmlTextWriter writer) {

        writer.WriteFullBeginTag("html");
        writer.WriteLine();

        writer.WriteFullBeginTag("body");
        writer.WriteLine();

        writer.WriteFullBeginTag("h1");
        writer.Write("Using the HtmlTextWriterClass");
        writer.WriteEndTag("h1");
        writer.WriteLine();

        // ...
        writer.WriteBeginTag("table");
        writer.AddStyleAttribute(HtmlTextWriterStyle.FontWeight, "bold");
        writer.AddStyleAttribute(HtmlTextWriterStyle.FontFamily, "verdana");
        writer.AddStyleAttribute(HtmlTextWriterStyle.FontSize, "14pt");
        writer.WriteAttribute("border","1");
        writer.Write(HtmlTextWriter.TagRightChar);
        writer.WriteLine();

        writer.Indent++;
        for (int i=0; i<maxRows; i++) {

            writer.WriteFullBeginTag("tr");
            writer.WriteLine();

            writer.Indent++;
            for (int j=0; j<maxCols; j++) {

                writer.WriteBeginTag("td");
                writer.WriteAttribute("valign","top");
                writer.WriteAttribute("bgcolor","lightblue");
                writer.Write(HtmlTextWriter.TagRightChar);

                writer.Write("Cell (" + i.ToString() + "," + j.ToString() + ")" );

                writer.WriteEndTag("td");
                writer.WriteLine();
            }

            writer.Indent--;
            writer.WriteEndTag("tr");
            writer.WriteLine();
        }
        writer.Indent--;

        // ...
        writer.WriteEndTag("table");
        writer.WriteLine();

        writer.WriteEndTag("body");
        writer.WriteLine();

        writer.WriteEndTag("html");
    }

</script>
