namespace PowerOfDotNet.Clubs.Board
{
	using System;
	using System.Data;
	using System.Data.SqlClient;
	using System.Drawing;
	using System.Web;
	using System.Web.UI;
	using System.Web.UI.WebControls;
	using System.Web.UI.HtmlControls;
	using System.Collections;

	/// <summary>
	///		List   Դϴ.
	/// </summary>
	public abstract class ClubList : PowerOfDotNet.PortalModuleControlEx
	{
		//protected PowerOfDotNet.Test.PagerSkinGrid ClubGrid;
		protected MyWebLibs.ServerControls.PagerSkinGrid ClubGrid;
		protected System.Web.UI.HtmlControls.HtmlInputHidden ClubParams;

		private int registerArrayCount = 0;
		protected System.Web.UI.WebControls.Image NewImage;
		protected System.Web.UI.HtmlControls.HtmlInputText txtSearch;
		protected System.Web.UI.WebControls.RadioButtonList rdobtnlstSearchType;
		protected System.Web.UI.WebControls.RequiredFieldValidator RequiredFieldValidator1;
		protected System.Web.UI.WebControls.Button btnSearch;
		protected System.Web.UI.WebControls.Button btnPrevSearch;

		private string dreamWeaverScript = @"
<script language=""JavaScript"" src=""{0}/Include/DreamweaverScript.js"">
</script>
		";

		private string makeClubContentParamScript = @"
<SCRIPT LANGUAGE=""JavaScript"">
		<!--

		function MakeClubContentParam()
		{{
			var mid = null;
			var pid = """";
			var groupNum = 0;
			var GroupArr = new Array();
			var param = """";
			var added = false;
	
			for (var i=0;i<__ClubListCheckBoxArr.length;i++)
			{{
				if (__ClubListCheckBoxArr[i][0].checked)
				{{
					if (mid == null)
					{{
						pid = __ClubListCheckBoxArr[i][1];
						mid = __ClubListCheckBoxArr[i][2];
					}}
					else if (mid != __ClubListCheckBoxArr[i][2])
					{{
						GroupArr[groupNum] = ""group"" + groupNum + ""="" + mid + "":"" + pid;
						groupNum++;
						pid = __ClubListCheckBoxArr[i][1];
						mid = __ClubListCheckBoxArr[i][2];
					}}
					else
					{{
						pid += "","" + __ClubListCheckBoxArr[i][1];
					}}
					added = true;
				}}
			}}
	
				if (added)
					GroupArr[groupNum] = ""group"" + groupNum + ""="" + mid + "":"" + pid;
	
				for (var i=0;i<GroupArr.length;i++)
				{{
					param += GroupArr[i] + ""&"";
					//alert(GroupArr[i]);
				}}
				//document.write(param);
				var uri = ""{0}&"" + {1}.value + ""&"" + param;
				//alert(uri);
				window.location.href = uri;
			}}

		//-->
		</SCRIPT>
";
		protected System.Web.UI.WebControls.Label lblSqlConditions;
		protected System.Web.UI.WebControls.CheckBox RowCheckbox;
		protected System.Web.UI.WebControls.Label Space;
		protected System.Web.UI.WebControls.Image Image1;

		private string ClubSqlConditionViewScript = @"
<SCRIPT LANGUAGE=""JavaScript"">
		<!--
		function _PowerOF_ClubShowSqlConditionViewScript()
		{
			x = (document.layers) ? e.pageX : document.body.scrollLeft+event.clientX;
			y = (document.layers) ? e.pageY : document.body.scrollTop+event.clientY;
			MM_changeProp('dSqlCondition','','style.top', y-30 + '','DIV');

			var obj = MM_findObj('dSqlCondition');
			var left = document.body.clientWidth - ((document.body.clientWidth + 700) / 2);
			MM_changeProp('dSqlCondition','','style.left', left + '','DIV');
			MM_showHideLayers('dSqlCondition','','show');
		}
		//-->
</SCRIPT>
		";
		protected System.Web.UI.HtmlControls.HtmlInputButton btnWriteNew;
		protected System.Web.UI.WebControls.HyperLink hyplnkEdit;
		protected System.Web.UI.WebControls.Panel pnlHeader;
		//protected MyWebLibs.ServerControls.PagerSkinGrid ClubGrid;
		//protected System.Web.UI.HtmlControls.HtmlInputHidden ClubParams;

		private PowerOfDotNet.Components.BoardClubInfo _blInfo;
		private int _clubId;

		private void Page_Load(object sender, System.EventArgs e)
		{
			int boardId = MyWebLibs.Utilities.CommonMethods.RequestInt(Request.Params["TableId"], -1);
			_clubId = MyWebLibs.Utilities.CommonMethods.RequestInt(Request.Params["clubId"], -1);

			if (boardId == -1)
			{
				MyWebLibs.Utilities.CommonMethods.PrintMsgBack("߸ ĶԴϴ.");
				return;
			}

			//߱Ⱓ  ̷ Ѵ.
			//this.RemoveObjectCache("BoardClubTableInfo" + boardId);
			//ɽÿ   ´.
			_blInfo = (PowerOfDotNet.Components.BoardClubInfo)this.GetObjectFromCache("BoardClubTableInfo" + boardId);
			if (_blInfo == null)
			{
				PowerOfDotNet.Components.BoardClubDB db = new PowerOfDotNet.Components.BoardClubDB();
				_blInfo = db.GetBoardInfo(boardId);

				this.SetObjectToCache("BoardClubTableInfo" + boardId, _blInfo, 30);
			}

			if (!IsPostBack)
			{
				Rebind();
				if (this.IsEditable)
				{
					hyplnkEdit.Text = "";
					hyplnkEdit.NavigateUrl = "/Clubs/Board/EditModules/ClubListEdit.aspx?moduleId=" + 
						this.ModuleId + "&clubId=" + _clubId + "&TableId=" + boardId;
				}
				pnlHeader.Style["text-align"] = "center";
			}

			//ŸƲ 
			switch (_blInfo.BBSDisplayType)
			{
				case 0 :
					pnlHeader.Controls.Add(new LiteralControl(_blInfo.BBSSubject));
					pnlHeader.Style["font-size"] = "16px";
					pnlHeader.Style["font-weight"] = "bold";
					break;
				case 1 :
					pnlHeader.Controls.Add(new LiteralControl("<img src='" + _blInfo.BBSImage + "' />"));
					break;
				case 2 :
					pnlHeader.Controls.Add(new LiteralControl(_blInfo.BBSHtml));
					break;
			}

			Components.ClubInfo clubInfo = Clubs.ClubsUtil.GetClubInfo(this, _clubId);
			if (Clubs.ClubsUtil.CheckUserAuthorityForGongJi(Page.User.Identity.Name, clubInfo, _blInfo))
			{
				btnWriteNew.Attributes["onclick"] = "window.location.href='" + 
					GetLink(_blInfo.BBSPageNameWrite)  + 
					"&TableId=" + boardId + "&clubId=" + _clubId + "'";
			}
			else
			{
				btnWriteNew.Visible = false;
			}

			txtSearch.Attributes["onkeypress"] = "if (event.keyCode==13 && Page_ClientValidate()) {" + 
									Page.GetPostBackEventReference(btnSearch,"") + ";return false;}";
			makeClubContentParamScript = String.Format(makeClubContentParamScript, 
				GetLink(_blInfo.BBSPageNameContent) + "&TableId=" + boardId + "&clubId=" + _clubId, 
				"document.getElementById(\"" + ClubParams.ClientID + "\")");
			Page.RegisterClientScriptBlock("makeClubContentParamScript", makeClubContentParamScript);
			//this.DataBind();
			
			string path = Request.ApplicationPath;
			if (path[path.Length-1] == '/')
				path = path.Substring(0, path.Length-1);
			dreamWeaverScript = String.Format(dreamWeaverScript, path);
			Page.RegisterClientScriptBlock("dreamWeaverScript", dreamWeaverScript);
			Page.RegisterClientScriptBlock("ClubSqlConditionViewScript", ClubSqlConditionViewScript);

			//Խù ȸ ߺǴ   Ѵ.
			this.Session["ClubForVistedIncrease"] = Request.RawUrl;
		}

		public void Rebind()
		{
			ClubGrid.DataSource = CreateDataSource();
			//ClubGrid.DataBind();
			this.DataBind();
		}

		//Ÿҽ 
		private ICollection CreateDataSource()
		{
			
			DataTable dt = new DataTable();
			DataRow dr;

			dt.Columns.Add(new DataColumn("PID", typeof(Int32)));
			dt.Columns.Add(new DataColumn("No", typeof(Int32)));
			dt.Columns.Add(new DataColumn("Subject", typeof(string)));
			dt.Columns.Add(new DataColumn("Writer", typeof(string)));
			dt.Columns.Add(new DataColumn("Viewed", typeof(Int32)));
			dt.Columns.Add(new DataColumn("RegDate", typeof(string)));
			dt.Columns.Add(new DataColumn("Space", typeof(string)));
			dt.Columns.Add(new DataColumn("IsNew", typeof(bool)));
			dt.Columns.Add(new DataColumn("MID", typeof(Int32)));
			dt.Columns.Add(new DataColumn("FileCount", typeof(bool)));

			int intRecCount, intPageCount;
			PowerOfDotNet.Components.BoardClubDB db = new PowerOfDotNet.Components.BoardClubDB();
			SqlDataReader sdr;

			int intPageSize = ClubGrid.PageSize;
			string sqlCondition = GetSqlCondition();
			if (sqlCondition == "")
				sdr = db.GetList(_blInfo.BBSTable, ClubGrid.CurrentPageIndex+1, intPageSize, out intRecCount, out intPageCount);
			else
				sdr = db.GetListWithWhere(_blInfo.BBSTable, ClubGrid.CurrentPageIndex+1, intPageSize, sqlCondition, out intRecCount, out intPageCount);

			ClubGrid.VirtualItemCount = intRecCount;
			//Խù ȣ ϱ Ѵ.
			int intIndex = intRecCount - (intPageSize * ClubGrid.CurrentPageIndex);
			while (sdr.Read())
			{
				dr = dt.NewRow();

				dr[0] = sdr.GetInt64(0); //PID
				dr[1] = intIndex--; // Խùȣ
				dr[2] = sdr.GetString(1); //Subject
				dr[3] = sdr.GetString(2); //Writer
				dr[4] = sdr.GetInt32(3); //ȸ
				dr[5] = sdr.GetDateTime(4).ToString("yyyy MM dd"); //RegDate
				DateTime dtRegDate = sdr.GetDateTime(4);
				dr[7] = dtRegDate >= DateTime.Now.AddDays(-1);//New ̹ ÷ 
				dr[8] = sdr.GetInt32(7); //MID
				dr[9] = sdr.GetByte(8) > 0; // 

				string sEmail = sdr.GetString(5);
				// ּҰ  ũ
				if (sEmail != null && sEmail != String.Empty)
				{
					dr[3] = "<a href=\"mailto:" + sEmail + "\">" + dr[3] + "</a>";				
				}

				string sSpace = "";
				// 鿩
				for (int i=0;i<sdr.GetInt32(6);i++) 	sSpace += "&nbsp;&nbsp;";
				dr[6] = sSpace;

				dt.Rows.Add(dr);
			}

			DataView dv = new DataView(dt);
			return dv;
		}

		protected string GetTarget(TableCellCollection oc)
		{
			string pid = oc[0].Text;
			string mid = oc[1].Text;
			string retStr = GetLink(_blInfo.BBSPageNameContent);

			retStr += "&TableId=" + _blInfo.BBSID;
			retStr += "&clubId=" + _clubId;
			retStr += "&page=" + ClubGrid.CurrentPageIndex.ToString();
			retStr += "&group0=" + mid + ":" + pid;

			return retStr;
		}

		private void Page_PreRender(object sender, System.EventArgs e)
		{
			btnPrevSearch.Visible = (GetSqlLevel() > 0);
			btnPrevSearch.Attributes["onMouseOver"] = "_PowerOF_ClubShowSqlConditionViewScript();"; 
			btnPrevSearch.Attributes["onMouseOut"] = "MM_showHideLayers('dSqlCondition','','hide');";
			lblSqlConditions.Text = GetUserReaderbleSqlCondition();
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN:  ȣ ASP.NET Web Form ̳ʿ ʿմϴ.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		///		̳  ʿ ޼Դϴ.
		///		 ޼  ڵ   ʽÿ.
		/// </summary>
		private void InitializeComponent()
		{
			this.ClubGrid.ItemDataBound += new System.Web.UI.WebControls.DataGridItemEventHandler(this.ClubGrid_ItemDataBound);
			this.btnSearch.Click += new System.EventHandler(this.btnSearch_Click);
			this.btnPrevSearch.Click += new System.EventHandler(this.btnPrevSearch_Click);
			this.Load += new System.EventHandler(this.Page_Load);
			this.PreRender += new System.EventHandler(this.Page_PreRender);

		}
		#endregion

		private void ClubGrid_PageIndexChanged(object source, System.Web.UI.WebControls.DataGridPageChangedEventArgs e)
		{
			ClubGrid.CurrentPageIndex = e.NewPageIndex;
			//start_index = PagerSkinGrid1.CurrentPageIndex * PagerSkinGrid1.PageSize;
			Rebind();
		
		}

		private void ClubGrid_ItemCreated(object sender, System.Web.UI.WebControls.DataGridItemEventArgs e)
		{
		}

		//  ޼ҵ Ѵ.
		//  ޼ҵ  ڵ   ʴ´.
		//  ޼ҵ带 ϴİ ߿ϴ.
		private void ClubGrid_ItemDataBound(object sender, System.Web.UI.WebControls.DataGridItemEventArgs e)
		{
			if(e.Item.ItemType == ListItemType.Item || 
				e.Item.ItemType == ListItemType.AlternatingItem)
			{
				if (((ICollection)((DataGrid)sender).DataSource).Count > registerArrayCount)
				{
					string pid = e.Item.Cells[0].Text;
					string mid = e.Item.Cells[1].Text;
					Control oc = e.Item.Cells[2].FindControl("RowCheckbox");
					this.Page.RegisterArrayDeclaration("__ClubListCheckBoxArr", "new Array(document.getElementById(\"" + oc.ClientID + "\")," + pid + "," + mid + ")");
					registerArrayCount++; // ޼ҵ尡 ѹ̻ ݺǴ 찡 Ƿ
				}
			}
		
		}

		private void ClubGrid_PreRender(object sender, System.EventArgs e)
		{
			ClubParams.Value = "page=" + ClubGrid.CurrentPageIndex.ToString();
		}

		/*private void btnSearch_ServerClick(object sender, System.EventArgs e)
		{
			int sqlLev = SaveSqlCondition(rdobtnlstSearchType.SelectedItem.Value + " Like '%" + txtSearch.Value + "%'");
			string sql = GetSqlCondition();
			Rebind();
		}
		*/

		private int GetSqlLevel()
		{
			string strSqlLev;
			try
			{
				strSqlLev = this.Session["sqlLev"].ToString();
			}
			catch
			{
				strSqlLev = "";
				this.Session["sqlLev"] = "";
			}

			if (strSqlLev == "")
				return 0;
			else
				return Convert.ToInt32(strSqlLev);

		}

		//Ǻ sql̵ where 
		private string GetSqlCondition()
		{
			string sqlParm = "";
			int sqlLev = GetSqlLevel();

			if (sqlLev == 0)
				return "";

			for (int i=1; i<=sqlLev; i++)
			{
				if (sqlParm == "")
					sqlParm += this.Session["sql" + i.ToString()].ToString();
				else
					sqlParm += " and " + this.Session["sql" + i.ToString()].ToString();
			}

			return " where " + sqlParm + " ";
		}

		private string GetUserReaderbleSqlCondition()
		{
			string sqlParm = "";
			int sqlLev = GetSqlLevel();

			if (sqlLev == 0)
				return "";

			for (int i=1; i<=sqlLev; i++)
			{
				if (sqlParm == "")
					sqlParm += this.Session["sqlKey" + i.ToString()].ToString();
				else
					sqlParm += ", " + this.Session["sqlKey" + i.ToString()].ToString();
				sqlParm += "="+this.Session["sqlCondition" + i.ToString()].ToString();
			}

			return sqlParm;
		}

		//˻  
		private int SaveSqlCondition(string key, string condition)
		{
			int sqlLev = GetSqlLevel();

			sqlLev++;
			this.Session["sqlLev"] = sqlLev;
			this.Session["sqlKey" + sqlLev.ToString()] = key;
			this.Session["sqlCondition" + sqlLev.ToString()] = condition;
			this.Session["sql" + sqlLev.ToString()] = key + " Like '%" + condition + "%'";

			return sqlLev;
		}

		private void btnSearch_Click(object sender, System.EventArgs e)
		{
			int sqlLev = SaveSqlCondition(rdobtnlstSearchType.SelectedItem.Value, txtSearch.Value);
			string sql = GetSqlCondition();
			Rebind();
		}

		private int RemoveLastSqlCondition()
		{
			int sqlLev = GetSqlLevel();
			this.Session["sqlLev"] = sqlLev - 1;
			this.Session.Remove("sql" + sqlLev.ToString());

			return sqlLev-1;
		}

		private void btnPrevSearch_Click(object sender, System.EventArgs e)
		{
			RemoveLastSqlCondition();
			Rebind();
		}
	}
}
