namespace PowerOfDotNet.MyPage
{
	using System;
	using System.Data;
	using System.Data.SqlClient;
	using System.Data.Common;
	using System.Drawing;
	using System.Web;
	using System.Web.UI.WebControls;
	using System.Web.UI.HtmlControls;
	using System.Collections;
	using System.Configuration;

	/// <summary>
	///		MyPageMain   Դϴ.
	/// </summary>
	public abstract class MyPageMain : PowerOfDotNet.PortalModuleControlEx
	{
		protected PowerOfDotNet.Avatar.AvatarPlugIn AvatarPlugIn1;
		protected System.Web.UI.WebControls.Label lblTodayPlan;

		protected string _userName;
		protected string _userId;
		protected string _recivedNewMailCount;
		protected string _recivedEntireMailCount;
		protected string _sentNewMailCount;
		protected string _sentEntireMailCount;
		protected string _wastebasketNewMailCount;
		protected string _wastebasketEntireMailCount;
		protected int _userEntireSpace;
		protected int _userUsedSpace;
		protected int _userFreeSpace;
		protected string _spaceGraphHeight;
		protected System.Web.UI.WebControls.DataList datlstMyClubs;
		protected string _newMessageCount;

		protected string _clubSubMainLink;

		private void Page_Load(object sender, System.EventArgs e)
		{
			_userId = this.Page.User.Identity.Name;
			AvatarPlugIn1.UserID = _userId;
			AvatarPlugIn1.ViewFrame = false.ToString();
			AvatarPlugIn1.Position = "";
			AvatarPlugIn1.OnClick = "window.location.href='" + GetLink("ƹŸ") + "'";

			PowerOfDotNet.Components.MyPageDB db = new PowerOfDotNet.Components.MyPageDB();
			SqlDataReader dr = db.GetDateContent(_userId, DateTime.Today);
			if (dr.Read())
				lblTodayPlan.Text = dr["rtNote"].ToString().Replace("\n", "<br>");
			dr.Close();

			_clubSubMainLink = GetLink("Ŭ");

			if (!this.IsPostBack)
			{
				_userName = Request.Cookies["usersInfo"]["Name"].ToString();

				PowerOfDotNet.Components.WebmailDB dbWebmail = new PowerOfDotNet.Components.WebmailDB();
				_recivedNewMailCount = dbWebmail.GetUserNetYetReadMailCount(_userId, 0).ToString();
				_recivedEntireMailCount = dbWebmail.GetUserMailCount(_userId, 0).ToString();
				_sentNewMailCount = dbWebmail.GetUserNetYetReadMailCount(_userId, 1).ToString();
				_sentEntireMailCount = dbWebmail.GetUserMailCount(_userId, 1).ToString();
				_wastebasketNewMailCount = dbWebmail.GetUserNetYetReadMailCount(_userId, 2).ToString();
				_wastebasketEntireMailCount = dbWebmail.GetUserMailCount(_userId, 2).ToString();

				PowerOfDotNet.AdminDB dbAdmin = new PowerOfDotNet.AdminDB();
				try 
				{
					//_userEntireSpace = Convert.ToInt32(ConfigurationSettings.AppSettings["MailLimitSize"]) * 1024;
					_userEntireSpace = Convert.ToInt32(dbAdmin.GetGlobalSetting("MailLimitSize")) * 1024;
				}
				catch
				{
					_userEntireSpace = 20 * 1024;
				}
				_userUsedSpace = dbWebmail.GetUserMailTotalSize(_userId) / 1024;
				_userFreeSpace = _userEntireSpace - _userUsedSpace;
				//177 ׷ 
				_spaceGraphHeight = ((_userUsedSpace*100/_userEntireSpace) * 177 / 100).ToString();

				PowerOfDotNet.Components.MyPageDB dbMyPage = new PowerOfDotNet.Components.MyPageDB();
				_newMessageCount = dbMyPage.GetDateContent(_userId).ToString();

				PowerOfDotNet.Components.ClubsDB clubDb = new PowerOfDotNet.Components.ClubsDB();
				SqlDataReader clubDr = clubDb.GetUserClubs(Page.User.Identity.Name);
				datlstMyClubs.DataSource = clubDr;

				this.DataBind();
			}

		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN:  ȣ ASP.NET Web Form ̳ʿ ʿմϴ.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		///		̳  ʿ ޼Դϴ.
		///		 ޼  ڵ   ʽÿ.
		/// </summary>
		private void InitializeComponent()
		{
			this.datlstMyClubs.ItemDataBound += new System.Web.UI.WebControls.DataListItemEventHandler(this.datlstMyClubs_ItemDataBound);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		private void datlstMyClubs_ItemDataBound(object sender, System.Web.UI.WebControls.DataListItemEventArgs e)
		{
			if(e.Item.ItemType == ListItemType.Item || 
				e.Item.ItemType == ListItemType.AlternatingItem) {
				int clubId = (int)((DbDataRecord)e.Item.DataItem)["ClubID"];
				string link = _clubSubMainLink +"&clubId=" + clubId;

				HtmlAnchor a = (HtmlAnchor)e.Item.FindControl("aClub");
				a.Attributes["href"] = link;
			}
		}
	}
}
