using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using System.Data.SqlClient;
using System.Text.RegularExpressions;

namespace PowerOfDotNet.NewStudy.Lacture
{
	public class GetLactureHTMLContent : System.Web.UI.Page
	{
		protected System.Web.UI.WebControls.PlaceHolder PlaceHolder1;

		private void Page_Load(object sender, System.EventArgs e)
		{
			int intID = Convert.ToInt32(Request.Params["ID"]);
			string tableName = Request.Params["Table"].ToString();

			PowerOfDotNet.Components.BoardLactureDB oDb = new PowerOfDotNet.Components.BoardLactureDB();

			SqlDataReader sdr = oDb.GetContent(tableName, intID);
			sdr.Read();

			PlaceHolder1.Controls.Add(new LiteralControl(
				ConvertToDBLink(sdr.GetString(3), intID, tableName)));
		}

		//ͺ̽ ̹  URL 
		private string ConvertToDBLink(string content, int ID, string tableName)
		{
			Regex ContentRegex = new Regex(@"\${2}(?<filename>[^\$]+)\${2}");

			Match m = ContentRegex.Match(content);

			if ( m.Success ) {
				string retContent = ContentRegex.Replace(content ,"GetLactureImage.ashx?ID=" + ID + "&Table=" + tableName + "&FileName=${filename}&bypass=true");
				return retContent;
			} 
			else {
				return content;
			}
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN:  ȣ ASP.NET Web Form ̳ʿ ʿմϴ.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// ̳  ʿ ޼Դϴ.
		///  ޼  ڵ   ʽÿ.
		/// </summary>
		private void InitializeComponent()
		{    
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion
	}
}
