/*
 * 2004 2 20 
 * */

using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Data.SqlClient;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;

namespace PowerOfDotNet.Avatar.EditModules
{
	/// <summary>
	/// AvatarAdminList   Դϴ.
	/// </summary>
	public class AvatarAdminList : System.Web.UI.Page
	{
		protected System.Web.UI.WebControls.DataGrid datgrdAvatar;
		protected System.Web.UI.WebControls.HyperLink hyplnkNewItem;
		private DataSet avatarDS;
	
		private void Page_Load(object sender, System.EventArgs e)
		{
			if (!IsPostBack)
			{
				BindData();
			}
		}

		private void BindData()
		{
			PowerOfDotNet.Components.AvatarDB db = new PowerOfDotNet.Components.AvatarDB();
			avatarDS = db.GetAllItems();
			datgrdAvatar.DataSource = avatarDS.Tables["AvatarItems"].DefaultView;
			datgrdAvatar.DataBind();
		}

		protected string GetEditLink(DataListItem Container)
		{
			TableCell cell = (TableCell)Container.Parent.Parent;
			LinkButton editButton = (LinkButton)cell.FindControl("lnkbtnEdit");
			return this.GetPostBackClientHyperlink(editButton, "");
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN:  ȣ ASP.NET Web Form ̳ʿ ʿմϴ.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// ̳  ʿ ޼Դϴ.
		///  ޼  ڵ   ʽÿ.
		/// </summary>
		private void InitializeComponent()
		{    
			this.datgrdAvatar.PageIndexChanged += new System.Web.UI.WebControls.DataGridPageChangedEventHandler(this.datgrdAvatar_PageIndexChanged);
			this.datgrdAvatar.CancelCommand += new System.Web.UI.WebControls.DataGridCommandEventHandler(this.datgrdAvatar_CancelCommand);
			this.datgrdAvatar.PreRender += new System.EventHandler(this.datgrdAvatar_PreRender);
			this.datgrdAvatar.EditCommand += new System.Web.UI.WebControls.DataGridCommandEventHandler(this.datgrdAvatar_EditCommand);
			this.datgrdAvatar.UpdateCommand += new System.Web.UI.WebControls.DataGridCommandEventHandler(this.datgrdAvatar_UpdateCommand);
			this.datgrdAvatar.DeleteCommand += new System.Web.UI.WebControls.DataGridCommandEventHandler(this.datgrdAvatar_DeleteCommand);
			this.datgrdAvatar.ItemDataBound += new System.Web.UI.WebControls.DataGridItemEventHandler(this.datgrdAvatar_ItemDataBound);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		private void datgrdAvatar_ItemDataBound(object sender, System.Web.UI.WebControls.DataGridItemEventArgs e)
		{
			if(e.Item.ItemType == ListItemType.Item || 
				e.Item.ItemType == ListItemType.AlternatingItem)
			{
				DataView _ItemImages = avatarDS.Tables["AvatarItemImages"].DefaultView;
				_ItemImages.RowFilter = "ItemID='" + e.Item.Cells[0].Text + "'";
				
				DataList dlItemImages = (DataList)e.Item.Cells[1].FindControl("datlstImage");

				dlItemImages.DataSource = _ItemImages;
				dlItemImages.DataBind();
			}
			else if(e.Item.ItemType == ListItemType.EditItem)
			{
				/*
				//ó ̼ ũƮ   ȾƼ ̷ ߾µ
				//߿ ̻ϰ Ŵ± ??
				RequiredFieldValidator rfValidator = (RequiredFieldValidator)e.Item.Cells[1].FindControl("Requiredfieldvalidator1");
				//rfValidator = new RequiredFieldValidator();
				//RequiredFieldValidator rfValidator = new RequiredFieldValidator();
				rfValidator.ControlToValidate = "txtItemName";
				rfValidator.ErrorMessage = "Է ʼ Դϴ.";
				*/

				MyWebLibs.Utilities.CommonMethods.GetForm(this).Enctype = "multipart/form-data";

				PowerOfDotNet.Components.AvatarDB db = new PowerOfDotNet.Components.AvatarDB();

				DropDownList drpdnlstPosition = (DropDownList)e.Item.Cells[1].FindControl("drpdnlstPosition");
				drpdnlstPosition.DataSource = db.GetPositions();;
				drpdnlstPosition.DataTextField = "Description";
				drpdnlstPosition.DataValueField = "PositionID";
				drpdnlstPosition.DataBind();

				CheckBoxList chkboxlstDependPosition = (CheckBoxList)e.Item.Cells[1].FindControl("chkboxlstDependPosition");
				chkboxlstDependPosition.DataSource = db.GetPositions();
				chkboxlstDependPosition.DataTextField = "Description";
				chkboxlstDependPosition.DataValueField = "PositionID";
				chkboxlstDependPosition.DataBind();

				DropDownList drpdnlstCategory = (DropDownList)e.Item.Cells[1].FindControl("drpdnlstCategory");
				drpdnlstCategory.DataSource = db.GetCategory();
				drpdnlstCategory.DataTextField = "Subject";
				drpdnlstCategory.DataValueField = "ID";
				drpdnlstCategory.DataBind();

				DataView dv = (DataView)((DataGrid)sender).DataSource;
				DataGrid dg = (DataGrid)sender;
				int rowIndex = dg.CurrentPageIndex * dg.PageSize + dg.EditItemIndex;

				TextBox txtItemName = (TextBox)e.Item.Cells[1].FindControl("txtItemName");
				txtItemName.Text = dv[rowIndex]["ItemName"].ToString();

				TextBox txtCost = (TextBox)e.Item.Cells[1].FindControl("txtCost");
				txtCost.Text = dv[rowIndex]["Cost"].ToString();

				TextBox txtThumbnailImage = (TextBox)e.Item.Cells[1].FindControl("txtThumbnailImage");
				txtThumbnailImage.Text = dv[rowIndex]["ThumbnailImage"].ToString();

				foreach (ListItem item in drpdnlstCategory.Items)
					if (item.Value == dv[rowIndex]["CategoryID"].ToString())
						item.Selected = true;

				foreach (ListItem item in drpdnlstPosition.Items)
					if (item.Value == dv[rowIndex]["PositionID"].ToString())
						item.Selected = true;

				RadioButtonList rdobtnlstSex = (RadioButtonList)e.Item.Cells[1].FindControl("rdobtnlstSex");
				rdobtnlstSex.SelectedIndex = (int)(byte)dv[rowIndex]["Sex"];
				

				SqlDataReader drDepended = db.GetDependedPositions((int)dv[rowIndex]["ID"]);
				while (drDepended.Read())
				{
					foreach (ListItem item in chkboxlstDependPosition.Items)
						if (item.Value == drDepended["PositionID"].ToString())
							item.Selected = true;
				}
				drDepended.Close();

				RadioButtonList rdobtnlstFrontLayerPos = (RadioButtonList)e.Item.Cells[1].FindControl("rdobtnlstFrontLayerPos");
				RadioButtonList rdobtnlstBackLayerPos = (RadioButtonList)e.Item.Cells[1].FindControl("rdobtnlstBackLayerPos");
				SqlDataReader drImages = db.GetItemImages((int)dv[rowIndex]["ID"]);
				while (drImages.Read())
				{
					int layerNum = (int)drImages["LayerNum"];
					if (layerNum >= 20 && layerNum < 30)
					{
						rdobtnlstBackLayerPos.SelectedIndex = layerNum % 10;
					}
					else
					{
						rdobtnlstFrontLayerPos.SelectedIndex = layerNum % 10;
					}
				}
				drImages.Close();

			}
		}

		private void datgrdAvatar_PageIndexChanged(object source, System.Web.UI.WebControls.DataGridPageChangedEventArgs e)
		{
			((DataGrid)source).CurrentPageIndex = e.NewPageIndex;
			BindData();
		}

		private void datgrdAvatar_PreRender(object sender, System.EventArgs e)
		{
		}

		private void datgrdAvatar_EditCommand(object source, System.Web.UI.WebControls.DataGridCommandEventArgs e)
		{
			((DataGrid)source).EditItemIndex = e.Item.ItemIndex;
			BindData();
		}

		private void datgrdAvatar_CancelCommand(object source, System.Web.UI.WebControls.DataGridCommandEventArgs e)
		{
			((DataGrid)source).EditItemIndex = -1;
			BindData();
		}

		private void datgrdAvatar_UpdateCommand(object source, System.Web.UI.WebControls.DataGridCommandEventArgs e)
		{
			int id = Convert.ToInt32(e.Item.Cells[0].Text);

			DropDownList drpdnlstPosition = (DropDownList)e.Item.Cells[1].FindControl("drpdnlstPosition");
			CheckBoxList chkboxlstDependPosition = (CheckBoxList)e.Item.Cells[1].FindControl("chkboxlstDependPosition");
			DropDownList drpdnlstCategory = (DropDownList)e.Item.Cells[1].FindControl("drpdnlstCategory");
			TextBox txtItemName = (TextBox)e.Item.Cells[1].FindControl("txtItemName");
			TextBox txtCost = (TextBox)e.Item.Cells[1].FindControl("txtCost");
			TextBox txtThumbnailImage = (TextBox)e.Item.Cells[1].FindControl("txtThumbnailImage");
			RadioButtonList rdobtnlstSex = (RadioButtonList)e.Item.Cells[1].FindControl("rdobtnlstSex");
			RadioButtonList rdobtnlstFrontLayerPos = (RadioButtonList)e.Item.Cells[1].FindControl("rdobtnlstFrontLayerPos");
			RadioButtonList rdobtnlstBackLayerPos = (RadioButtonList)e.Item.Cells[1].FindControl("rdobtnlstBackLayerPos");
			HtmlInputFile fileThumbnail = (HtmlInputFile)e.Item.Cells[1].FindControl("fileThumbnail");
			HtmlInputFile fileFrontImage = (HtmlInputFile)e.Item.Cells[1].FindControl("fileFrontImage");
			HtmlInputFile fileBackImage = (HtmlInputFile)e.Item.Cells[1].FindControl("fileBackImage");
			CheckBox chkboxFrontUpdate = (CheckBox)e.Item.Cells[1].FindControl("chkboxFrontUpdate");
			CheckBox chkboxBackUpdate = (CheckBox)e.Item.Cells[1].FindControl("chkboxBackUpdate");

			PowerOfDotNet.Components.AvatarDB db = new PowerOfDotNet.Components.AvatarDB();
			db.UpdateItem(id, txtItemName.Text, Convert.ToInt32(drpdnlstPosition.SelectedItem.Value),
				chkboxlstDependPosition.Items, Convert.ToInt32(drpdnlstCategory.SelectedItem.Value),
				Convert.ToInt32(txtCost.Text), rdobtnlstSex.SelectedIndex, txtThumbnailImage.Text, chkboxFrontUpdate.Checked,
				fileFrontImage,	rdobtnlstFrontLayerPos.SelectedIndex, chkboxBackUpdate.Checked, 
				fileBackImage, rdobtnlstBackLayerPos.SelectedIndex);

			((DataGrid)source).EditItemIndex = -1;
			BindData();
		}

		private void datgrdAvatar_DeleteCommand(object source, System.Web.UI.WebControls.DataGridCommandEventArgs e)
		{
			int id = Convert.ToInt32(e.Item.Cells[0].Text);

			PowerOfDotNet.Components.AvatarDB db = new PowerOfDotNet.Components.AvatarDB();
			db.DeleteItem(id);
			((DataGrid)source).EditItemIndex = -1;
			BindData();
		}
	}
}
