/*
 * 2004 2 20 
 * */

namespace PowerOfDotNet.Clubs
{
	using System;
	using System.Data;
	using System.Data.SqlClient;
	using System.Drawing;
	using System.Web;
	using System.Web.UI;
	using System.Web.UI.WebControls;
	using System.Web.UI.HtmlControls;
	using System.Collections;
	using System.Text.RegularExpressions;

	/// <summary>
	///		FragClubBoard   Դϴ.
	/// </summary>
	public abstract class FragClubBoard : PowerOfDotNet.PortalModuleControlEx
	{
		#region ɺ ڿ  

		private const string BOARD_LAYOUT_ROW_OPEN = "{{Խ෹̾ƿ}}";
		private const string BOARD_LAYOUT_ROW_CLOSE = "{{Խ෹̾ƿ}}";

		private const string BOARD_COLUMN_SUBJECT = "{{Խ÷}}";
		private const string BOARD_COLUMN_WRITER = "{{Խۼ÷}}";
		private const string BOARD_COLUMN_REGDATE = "{{Խǳ¥÷}}";
		private const string BOARD_COLUMN_VIEWED = "{{Խȸ÷}}";
		private const string BOARD_COLUMN_NEW_IMAGE = "{{ԽNEW̹÷}}";

		private const string BOARD_DEF_COLUMN_NEW_IMAGE_BEGIN = "{{ԽNEW̹÷ǽ}}";
		private const string BOARD_DEF_COLUMN_NEW_IMAGE_END = "{{ԽNEW̹÷ǳ}}";

		private const string BOARD_DEF_ORDER_BEGIN = "{{Խǹȣ}}";
		private const string BOARD_DEF_ORDER_END = "{{Խǹȣ}}";
		private const string BOARD_DEF_WIDTH_BEGIN = "{{Խǳǽ}}";
		private const string BOARD_DEF_WIDTH_END = "{{Խǳǳ}}";
		private const string BOARD_DEF_HEIGHT_BEGIN = "{{Խǳǽ}}";
		private const string BOARD_DEF_HEIGHT_END = "{{Խǳǳ}}";
		private const string BOARD_DEF_ROW_COUNT_BEGIN = "{{Խ}}";
		private const string BOARD_DEF_ROW_COUNT_END = "{{Խ}}";

		private const string CLUB_DIR = "{{Ŭ͸}}";

		#endregion

		protected System.Web.UI.WebControls.DataList datlstSkinBoard;

		protected string _boardNewImage;

		private int _clubId;
		private int _boardId;
		//private string _boardSubject;
		private int _boardSoroOrder;
		private string _boardTableName;
		private int _boardRowCount = 6;
		private string _clubDir;
		private string _boardRowTemplate;

		private MatchCollection _mcTemplate;
		private Hashtable htSymboleSubstance = new Hashtable();

		private string _boardSkin;
		private LiteralControl _subjectControl;

		// Խ Ų Ǵ Ӽ
		public string BoardSkin	{
			set	{
				_boardSkin = value;
			}
		}

		//  Ʈ
		public LiteralControl SubjectControl {
			set {
				_subjectControl = value;
			}
		}

		private void Page_Load(object sender, System.EventArgs e)
		{
			_clubId = MyWebLibs.Utilities.CommonMethods.RequestInt(Request.Params["clubId"], -1);

			// {{...}} ɺ 
			Regex skinRegex = new Regex("(?<symbol>{{[^{}]+}})");
			MatchCollection mcMain = skinRegex.Matches(_boardSkin);

			RealizeSymbols(mcMain, _boardSkin);

			PowerOfDotNet.Components.ClubsDB db = new PowerOfDotNet.Components.ClubsDB();
			//SqlDataReader dr = db.GetBoardBySubject(_clubId, _boardSubject);

			try {
				SqlDataReader dr = db.GetBoardBySortOrder(_clubId, _boardSoroOrder-1);
			
				dr.Read();
				_boardTableName = dr["TableName"].ToString();
				_boardId = (int)dr["id"];
				//Խ  
				//_subjectControl Ʈ ClubSubMain.ascx ִ.
				_subjectControl.Text = dr["Subject"].ToString();
				dr.Close();
			}
			catch  {
				//throw ;
			}

			//Ŭ ͸  
			_clubDir = "clubId_" + _clubId;
			_clubDir = Page.MapPath("/Clubs/ClubsDir/" + _clubDir);

			htSymboleSubstance.Add(CLUB_DIR, _clubDir);

			_boardRowTemplate = GetPortion(_boardSkin, BOARD_LAYOUT_ROW_OPEN, BOARD_LAYOUT_ROW_CLOSE, mcMain);
			if (_boardRowTemplate == null)
				throw new Exception(BOARD_LAYOUT_ROW_OPEN + "(̳) " + BOARD_LAYOUT_ROW_CLOSE + " ǰ ߸Ǿϴ.");

			_mcTemplate = skinRegex.Matches(_boardRowTemplate);

			BindData();

			this.Session["ClubForVistedIncrease"] = Request.RawUrl;
		}

		public void BindData()
		{
			datlstSkinBoard.DataSource = CreateDataSource();
			datlstSkinBoard.DataBind();
		}

		//Ÿҽ 
		private ICollection CreateDataSource()
		{
			DataTable dt = new DataTable();
			DataRow dr;

			dt.Columns.Add(new DataColumn("PID", typeof(Int32)));
			dt.Columns.Add(new DataColumn("Subject", typeof(string)));
			dt.Columns.Add(new DataColumn("Writer", typeof(string)));
			dt.Columns.Add(new DataColumn("Viewed", typeof(Int32)));
			dt.Columns.Add(new DataColumn("RegDate", typeof(string)));
			dt.Columns.Add(new DataColumn("IsNew", typeof(bool)));
			dt.Columns.Add(new DataColumn("Link", typeof(string)));

			PowerOfDotNet.Components.ClubsDB db = new PowerOfDotNet.Components.ClubsDB();
			SqlDataReader sdr = db.GetBoardListUsingTop(_boardTableName, _boardRowCount);

			while (sdr.Read()) {
				dr = dt.NewRow();

				dr[0] = sdr["PID"]; //PID
				dr[1] = sdr["Subject"]; //Subject
				dr[2] = sdr["Writer"]; //Writer
				dr[3] = sdr["Visited"]; //ȸ
				DateTime regDate = Convert.ToDateTime(sdr["RegDate"]);
				dr[4] = regDate.ToString("yyyy-MM-dd"); //RegDate
				dr[5] = regDate >= DateTime.Now.AddDays(-1);//New ̹ ÷ 
				dr[6] = this.GetLink("Ŭ_") + "&TableId=" + _boardId + 
						"&clubId=" + _clubId + "&page=0&group0=" + sdr["MID"] + ":" + dr[0];

				dt.Rows.Add(dr);
			}
			sdr.Close();

			DataView dv = new DataView(dt);
			return dv;
		}


		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN:  ȣ ASP.NET Web Form ̳ʿ ʿմϴ.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		///		̳  ʿ ޼Դϴ.
		///		 ޼  ڵ   ʽÿ.
		/// </summary>
		private void InitializeComponent()
		{
			this.datlstSkinBoard.ItemDataBound += new System.Web.UI.WebControls.DataListItemEventHandler(this.datlstSkinBoard_ItemDataBound);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion


		//ItemDataBound ̺Ʈ  ׸񸶴 Ų ó Ѵ
		private void datlstSkinBoard_ItemDataBound(object sender, System.Web.UI.WebControls.DataListItemEventArgs e)
		{
			if(e.Item.ItemType == ListItemType.Item || 
				e.Item.ItemType == ListItemType.AlternatingItem) {
				ArrayList aControls = new ArrayList();
				Control oc;

				oc = e.Item.FindControl("placehdrSubject");
				aControls.Add(oc.Controls[0]);
				oc = e.Item.FindControl("placehdrWriter");
				aControls.Add(oc.Controls[0]);
				oc = e.Item.FindControl("placehdrRegDate");
				aControls.Add(oc.Controls[0]);
				oc = e.Item.FindControl("placehdrVisited");
				aControls.Add(oc.Controls[0]);
				oc = e.Item.FindControl("placehdrNewImage");
				aControls.Add(oc.Controls[0]);

				Control ocOutput = e.Item.FindControl("placehdrOutput");

				for (int i=0; i < _mcTemplate.Count; i++) {
					string frontPortion, backPortion;

					if (i == 0) {
						frontPortion = GetFrontPortion(_boardRowTemplate, _mcTemplate, i);
						if (frontPortion != String.Empty)
							ocOutput.Controls.Add(new LiteralControl(frontPortion));

						SetupEachControl(_mcTemplate[i], ocOutput, aControls);

						backPortion = GetBackPortion(_boardRowTemplate, _mcTemplate, i);
						if (backPortion != String.Empty)
							ocOutput.Controls.Add(new LiteralControl(backPortion));
					}
					else {
						SetupEachControl(_mcTemplate[i], ocOutput, aControls);

						backPortion = GetBackPortion(_boardRowTemplate, _mcTemplate, i);
						if (backPortion != String.Empty)
							ocOutput.Controls.Add(new LiteralControl(backPortion));
					}
				}
			}
		}

		//controlsȿ  DataBoundLiteralControl Ʈ ġ
		private const int ocSubject = 0;
		private const int ocWriter = 1;
		private const int ocRegDate = 2;
		private const int ocVisited = 3;
		private const int ocNewImage = 4;

		// ɺ ϴ Ʈ ߰Ѵ.
		private void SetupEachControl(Match m, Control output, ArrayList controls)
		{
			string symbolName = m.Value;

			switch (symbolName) {
				case BOARD_COLUMN_SUBJECT :
					output.Controls.Add((Control)controls[ocSubject]);
					break;
				case BOARD_COLUMN_WRITER :
					output.Controls.Add((Control)controls[ocWriter]);
					break;
				case BOARD_COLUMN_REGDATE :
					output.Controls.Add((Control)controls[ocRegDate]);
					break;
				case BOARD_COLUMN_VIEWED :
					output.Controls.Add((Control)controls[ocVisited]);
					break;
				case BOARD_COLUMN_NEW_IMAGE :
					output.Controls.Add((Control)controls[ocNewImage]);
					break;
				default :
					output.Controls.Add(new LiteralControl((string)htSymboleSubstance[symbolName]));
					break;
			}
		}

		//{{DEF_..._BEGIN}} {{DEF_..._END}} ̿ ǵ ڿ 
		//  htSymboleDef  Ѵ.
		private void RealizeSymbols(MatchCollection mc, string strSkin)
		{
			//_boardSubject = GetPortion(strSkin, BOARD_DEF_SUBJECT_BEGIN, BOARD_DEF_SUBJECT_END, mc);
			//if (_boardSubject != null)
			//	_boardSubject = _boardSubject.Trim();

			//Խ ȣ
			string sortOrder = GetPortion(strSkin, BOARD_DEF_ORDER_BEGIN, BOARD_DEF_ORDER_END, mc);
			if (sortOrder != null)
				_boardSoroOrder = int.Parse(sortOrder);

			//new ̹ 
			_boardNewImage = GetPortion(strSkin, BOARD_DEF_COLUMN_NEW_IMAGE_BEGIN, BOARD_DEF_COLUMN_NEW_IMAGE_END, mc);
			if (_boardNewImage != null)
				_boardNewImage = _boardNewImage.Trim();

			// ȣ
			string rowCount = GetPortion(strSkin, BOARD_DEF_ROW_COUNT_BEGIN, BOARD_DEF_ROW_COUNT_END, mc);
			if (rowCount != null)
				_boardRowCount = int.Parse(rowCount.Trim());

			//Խ 
			string boardWidth = GetPortion(strSkin, BOARD_DEF_WIDTH_BEGIN, BOARD_DEF_WIDTH_END, mc);
			if (boardWidth != null) {
				//⺻ ȼ
				UnitType widthType = UnitType.Pixel;
				double width;

				boardWidth = boardWidth.ToLower();
				//ۼƮ
				if (boardWidth.IndexOf("%") >= 0) {
					width = Convert.ToDouble(boardWidth.Replace("%", ""));
					widthType = UnitType.Percentage;
				}
				//px  ȼ
				else if (boardWidth.IndexOf("px") >= 0) {
					width = Convert.ToDouble(boardWidth.Replace("px", ""));
				}
				//ƹ͵  ȼ
				else {
					width = Convert.ToDouble(boardWidth);
				}
				datlstSkinBoard.Width = new Unit(width, widthType);
			}
			//Խ 
			string boardHeight = GetPortion(strSkin, BOARD_DEF_HEIGHT_BEGIN, BOARD_DEF_HEIGHT_END, mc);
			if (boardHeight != null) {
				UnitType heightType = UnitType.Pixel;
				double height;

				boardHeight = boardHeight.ToLower();
				if (boardHeight.IndexOf("%") >= 0) {
					height = Convert.ToDouble(boardHeight.Replace("%", ""));
					heightType = UnitType.Percentage;
				}
				else if (boardHeight.IndexOf("px") >= 0) {
					height = Convert.ToDouble(boardHeight.Replace("px", ""));
				}
				else {
					height = Convert.ToDouble(boardHeight);
				}
				datlstSkinBoard.Height = new Unit(height, heightType);
			}
		}

		//ɺ  ͷ̵ ڿ ´.
		private string GetFrontPortion(string origin, MatchCollection mc, int index)
		{
			if (index == 0)	{
				return origin.Substring(0, mc[index].Index);
			}
			else {
				return origin.Substring(mc[index-1].Index+mc[index-1].Length, 
					mc[index].Index - (mc[index-1].Index+mc[index-1].Length));
			}
		}

		//ɺ Ĺ ͷ̵ ڿ ´.
		private string GetBackPortion(string origin, MatchCollection mc, int index)
		{
			if (index == mc.Count-1) {
				return origin.Substring(mc[index].Index + mc[index].Length);
			}
			else {
				return origin.Substring(mc[index].Index + mc[index].Length, 
					mc[index + 1].Index - (mc[index].Index+mc[index].Length));
			}
		}

		//startSymbol enSynbol Ʈ ´.
		private string GetPortion(string origin, string startSymbol, string endSymbol, MatchCollection mc)
		{
			Match sm = FindMatche(mc, startSymbol);
			if (sm == null)
				return null;

			Match em = FindMatche(mc, endSymbol);
			if (em == null)
				return null;

			int iStart = sm.Index + sm.Length;
			int iLength = em.Index - iStart;

			return origin.Substring(iStart, iLength);
		}

		private Match FindMatche(MatchCollection mc, string search)
		{
			foreach (Match m in mc) {
				if (search == m.Value)
					return m;
			}

			return null;
		}
	}
}
